/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _COUNTERRPTYPE_H_
#define _COUNTERRPTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The CounterRPType complex type, which represents the
 * {http://counter.com}complexType 5 element.
 * @ingroup CounterRPType
 */
typedef struct CounterRPType_s CounterRPType;
/**
 * The CounterRPType_o complex type, which represents an optional instance
 * of a
 * {http://counter.com}complexType 5 element.
 * @ingroup CounterRPType
 */
typedef CounterRPType * CounterRPType_o;

/**
 * Namespace of the CounterRPType complex type
 * @ingroup CounterRPType
 */
#define COUNTERRPTYPE_NS "http://counter.com"
/**
 * Local part of the QName of the CounterRPType complex type
 * @ingroup CounterRPType
 */
#define COUNTERRPTYPE_LOCAL "CounterRPType"

/**
 * QName of the CounterRPType complex type
 * @ingroup CounterRPType
 */
extern xsd_QName CounterRPType_qname;
/**
 * Type information for serializing and deserializing CounterRPType elements
 * @ingroup CounterRPType
 */
extern struct globus_xsd_type_info_s CounterRPType_info;
/**
 * Type information for serializing and deserializing arrays of CounterRPType
 * elements
 * @ingroup CounterRPType
 */
extern struct globus_xsd_type_info_s CounterRPType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * CounterRPType without surrounding elements
 * @ingroup CounterRPType
 */
extern struct globus_xsd_type_info_s CounterRPType_contents_info;


#include "xsd_int.h"
#include "wsnt_TopicExpressionType_array.h"
#include "xsd_anyURI.h"
#include "xsd_dateTime.h"
#include "xsd_dateTime.h"
#include "xsd_boolean.h"
#include "CounterRPType_array.h"

/**
 * @defgroup CounterRPType Complex type: CounterRPType
 * @ingroup types
 */

/**
 * C structure for the CounterRPType complex type
 * @ingroup CounterRPType
 */
struct CounterRPType_s
{
    /** xsd_int subelement */
    xsd_int Value;
   /** Array of [1 .. Infinity] wsnt_TopicExpressionType elements */
    wsnt_TopicExpressionType_array Topic;
   /** Array of [1 .. Infinity] xsd_anyURI elements */
    xsd_anyURI_array TopicExpressionDialects;
    /** xsd_dateTime subelement */
    xsd_dateTime TerminationTime;
    /** xsd_dateTime subelement */
    xsd_dateTime CurrentTime;
    /** xsd_boolean subelement */
    xsd_boolean FixedTopicSet;

};

/**
 * Initialize a CounterRPType
 * @ingroup CounterRPType
 *
 * Allocates a new CounterRPType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * CounterRPType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
CounterRPType_init(
    CounterRPType ** inst);

/**
 * Destroy a CounterRPType
 * @ingroup CounterRPType
 *
 * Frees a CounterRPType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
CounterRPType_destroy(
    CounterRPType * inst);

/**
 * Copy a CounterRPType
 * @ingroup CounterRPType
 *
 * Perform a deep copy of a CounterRPType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The CounterRPType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source CounterRPType to be copied.
 */
globus_result_t
CounterRPType_copy(
    CounterRPType ** dest,
    const CounterRPType * src);

/**
 * Initialize the contents of a CounterRPType
 * @ingroup CounterRPType
 *
 * Initialize the contents of a CounterRPType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * CounterRPType_init(). The contents may be freed
 * by calling CounterRPType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized CounterRPType.
 */
globus_result_t
CounterRPType_init_contents(
    CounterRPType * instance);

/**
 * Destroy the contents of a CounterRPType
 * @ingroup CounterRPType
 *
 * Destroy the subelements and attributes of the given CounterRPType. 
 *
 * @param inst
 *     Pointer to a CounterRPType instance to destroy.
 */
void
CounterRPType_destroy_contents(
    CounterRPType * inst);

/**
 * Copy the contents of a CounterRPType
 * @ingroup CounterRPType
 *
 * Perform a deep copy of the contents of a CounterRPType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source CounterRPType to be copied.
 */
globus_result_t
CounterRPType_copy_contents(
    CounterRPType * dest,
    const CounterRPType * src);

/**
 * Serialize a CounterRPType
 * @ingroup CounterRPType_array
 * Serialize a CounterRPType structure.
 *
 * @param element_name
 *     The name of the element which will contain the CounterRPType.
 * @param val
 *     The CounterRPType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
CounterRPType_serialize(
    xsd_QName *                         element_name,
    CounterRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a CounterRPType
 * @ingroup CounterRPType_array
 * Serialize a CounterRPType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The CounterRPType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
CounterRPType_serialize_contents(
    xsd_QName *                         element_name,
    CounterRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a CounterRPType
 * @ingroup CounterRPType
 * Deserialize an element containing a CounterRPType element.
 *
 * @param element_name
 *     The name of the element which should enclose the CounterRPType.
 * @param val
 *     Pointer to the CounterRPType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
CounterRPType_deserialize(
    xsd_QName *                         element_name,
    CounterRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a CounterRPType
 * @ingroup CounterRPType
 * Deserialize a CounterRPType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the CounterRPType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
CounterRPType_deserialize_contents(
    xsd_QName *                         element_name,
    CounterRPType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional CounterRPType
 * @ingroup CounterRPType
 * Deserialize the next element if it contains a CounterRPType.
 *
 * @param element_name
 *     The name of the element which should enclose the CounterRPType.
 * @param instance
 *     Pointer to the <code>CounterRPType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
CounterRPType_deserialize_pointer(
    xsd_QName *                         element_name,
    CounterRPType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
CounterRPType_init_wrapper(
    void **                             object);
    
void
CounterRPType_destroy_wrapper(
    void *                              object);
    
globus_result_t
CounterRPType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
CounterRPType_init_contents_wrapper(
    void *                              object);
    
void
CounterRPType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
CounterRPType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
CounterRPType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
CounterRPType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
CounterRPType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
CounterRPType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
