/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC convert
 */

#ifndef _COUNTERSERVICE_H_
#define _COUNTERSERVICE_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#include "globus_handler.h"
#include "globus_soap_message.h"
#include "globus_xsd_type_registry.h"

#define COUNTERSERVICE_BASE_PATH "wsrf/services/CounterService"

extern xsd_QName CounterService_service_qname;

globus_result_t
CounterService_registry_add_types(
    globus_xsd_type_registry_t          registry);

globus_result_t
CounterService_registry_remove_types(
    globus_xsd_type_registry_t          registry);


#include "wsnt_GetCurrentMessageType.h"
#include "wsnt_GetCurrentMessageResponseType.h"
#include "wsnt_ResourceUnknownFaultType.h"
#include "wsnt_ResourceUnknownFault.h"
#include "wsnt_NoCurrentMessageOnTopicFaultType.h"
#include "wsnt_NoCurrentMessageOnTopicFault.h"
#include "wsnt_InvalidTopicExpressionFaultType.h"
#include "wsnt_InvalidTopicExpressionFault.h"
#include "wsnt_TopicNotSupportedFaultType.h"
#include "wsnt_TopicNotSupportedFault.h"
#include "wsnt_SubscribeType.h"
#include "wsnt_SubscribeResponseType.h"
#include "wsnt_TopicPathDialectUnknownFaultType.h"
#include "wsnt_TopicPathDialectUnknownFault.h"
#include "wsnt_ResourceUnknownFaultType.h"
#include "wsnt_ResourceUnknownFault.h"
#include "wsnt_SubscribeCreationFailedFaultType.h"
#include "wsnt_SubscribeCreationFailedFault.h"
#include "wsnt_InvalidTopicExpressionFaultType.h"
#include "wsnt_InvalidTopicExpressionFault.h"
#include "wsnt_TopicNotSupportedFaultType.h"
#include "wsnt_TopicNotSupportedFault.h"
#include "xsd_QName.h"
#include "wsrp_GetResourcePropertyResponseType.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrp_GetMultipleResourcePropertiesType.h"
#include "wsrp_GetMultipleResourcePropertiesResponseType.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrp_QueryResourcePropertiesType.h"
#include "wsrp_QueryResourcePropertiesResponseType.h"
#include "wsrp_UnknownQueryExpressionDialectFaultType.h"
#include "wsrp_UnknownQueryExpressionDialectFault.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_QueryEvaluationErrorFaultType.h"
#include "wsrp_QueryEvaluationErrorFault.h"
#include "wsrp_InvalidQueryExpressionFaultType.h"
#include "wsrp_InvalidQueryExpressionFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrl_DestroyType.h"
#include "wsrl_DestroyResponseType.h"
#include "wsrl_ResourceUnknownFaultType.h"
#include "wsrl_ResourceUnknownFault.h"
#include "wsrl_ResourceNotDestroyedFaultType.h"
#include "wsrl_ResourceNotDestroyedFault.h"
#include "wsrl_SetTerminationTimeType.h"
#include "wsrl_SetTerminationTimeResponseType.h"
#include "wsrl_TerminationTimeChangeRejectedFaultType.h"
#include "wsrl_TerminationTimeChangeRejectedFault.h"
#include "wsrl_ResourceUnknownFaultType.h"
#include "wsrl_ResourceUnknownFault.h"
#include "wsrl_UnableToSetTerminationTimeFaultType.h"
#include "wsrl_UnableToSetTerminationTimeFault.h"
#include "xsd_int.h"
#include "xsd_int.h"
#include "createCounterType.h"
#include "createCounterResponseType.h"

/* fault type declaration for the GetCurrentMessage operation */

typedef enum
{
    COUNTERPORTTYPE_GETCURRENTMESSAGE_NOFAULT = 0,
    COUNTERPORTTYPE_GETCURRENTMESSAGE_UNKNOWN_FAULT = 1,
    COUNTERPORTTYPE_GETCURRENTMESSAGE_RESOURCEUNKNOWNFAULT,
    COUNTERPORTTYPE_GETCURRENTMESSAGE_NOCURRENTMESSAGEONTOPICFAULT,
    COUNTERPORTTYPE_GETCURRENTMESSAGE_INVALIDTOPICEXPRESSIONFAULT,
    COUNTERPORTTYPE_GETCURRENTMESSAGE_TOPICNOTSUPPORTEDFAULT

} CounterPortType_GetCurrentMessage_fault_t;


/* qname for operation GetCurrentMessage */

extern xsd_QName CounterPortType_GetCurrentMessage_op_qname;



/* fault type declaration for the Subscribe operation */

typedef enum
{
    COUNTERPORTTYPE_SUBSCRIBE_NOFAULT = 0,
    COUNTERPORTTYPE_SUBSCRIBE_UNKNOWN_FAULT = 1,
    COUNTERPORTTYPE_SUBSCRIBE_TOPICPATHDIALECTUNKNOWNFAULT,
    COUNTERPORTTYPE_SUBSCRIBE_RESOURCEUNKNOWNFAULT,
    COUNTERPORTTYPE_SUBSCRIBE_SUBSCRIBECREATIONFAILEDFAULT,
    COUNTERPORTTYPE_SUBSCRIBE_INVALIDTOPICEXPRESSIONFAULT,
    COUNTERPORTTYPE_SUBSCRIBE_TOPICNOTSUPPORTEDFAULT

} CounterPortType_Subscribe_fault_t;


/* qname for operation Subscribe */

extern xsd_QName CounterPortType_Subscribe_op_qname;



/* fault type declaration for the GetResourceProperty operation */

typedef enum
{
    COUNTERPORTTYPE_GETRESOURCEPROPERTY_NOFAULT = 0,
    COUNTERPORTTYPE_GETRESOURCEPROPERTY_UNKNOWN_FAULT = 1,
    COUNTERPORTTYPE_GETRESOURCEPROPERTY_RESOURCEUNKNOWNFAULT,
    COUNTERPORTTYPE_GETRESOURCEPROPERTY_INVALIDRESOURCEPROPERTYQNAMEFAULT

} CounterPortType_GetResourceProperty_fault_t;


/* qname for operation GetResourceProperty */

extern xsd_QName CounterPortType_GetResourceProperty_op_qname;



/* fault type declaration for the GetMultipleResourceProperties operation */

typedef enum
{
    COUNTERPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_NOFAULT = 0,
    COUNTERPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_UNKNOWN_FAULT = 1,
    COUNTERPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_RESOURCEUNKNOWNFAULT,
    COUNTERPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_INVALIDRESOURCEPROPERTYQNAMEFAULT

} CounterPortType_GetMultipleResourceProperties_fault_t;


/* qname for operation GetMultipleResourceProperties */

extern xsd_QName CounterPortType_GetMultipleResourceProperties_op_qname;



/* fault type declaration for the QueryResourceProperties operation */

typedef enum
{
    COUNTERPORTTYPE_QUERYRESOURCEPROPERTIES_NOFAULT = 0,
    COUNTERPORTTYPE_QUERYRESOURCEPROPERTIES_UNKNOWN_FAULT = 1,
    COUNTERPORTTYPE_QUERYRESOURCEPROPERTIES_UNKNOWNQUERYEXPRESSIONDIALECTFAULT,
    COUNTERPORTTYPE_QUERYRESOURCEPROPERTIES_RESOURCEUNKNOWNFAULT,
    COUNTERPORTTYPE_QUERYRESOURCEPROPERTIES_QUERYEVALUATIONERRORFAULT,
    COUNTERPORTTYPE_QUERYRESOURCEPROPERTIES_INVALIDQUERYEXPRESSIONFAULT,
    COUNTERPORTTYPE_QUERYRESOURCEPROPERTIES_INVALIDRESOURCEPROPERTYQNAMEFAULT

} CounterPortType_QueryResourceProperties_fault_t;


/* qname for operation QueryResourceProperties */

extern xsd_QName CounterPortType_QueryResourceProperties_op_qname;



/* fault type declaration for the Destroy operation */

typedef enum
{
    COUNTERPORTTYPE_DESTROY_NOFAULT = 0,
    COUNTERPORTTYPE_DESTROY_UNKNOWN_FAULT = 1,
    COUNTERPORTTYPE_DESTROY_RESOURCEUNKNOWNFAULT,
    COUNTERPORTTYPE_DESTROY_RESOURCENOTDESTROYEDFAULT

} CounterPortType_Destroy_fault_t;


/* qname for operation Destroy */

extern xsd_QName CounterPortType_Destroy_op_qname;



/* fault type declaration for the SetTerminationTime operation */

typedef enum
{
    COUNTERPORTTYPE_SETTERMINATIONTIME_NOFAULT = 0,
    COUNTERPORTTYPE_SETTERMINATIONTIME_UNKNOWN_FAULT = 1,
    COUNTERPORTTYPE_SETTERMINATIONTIME_TERMINATIONTIMECHANGEREJECTEDFAULT,
    COUNTERPORTTYPE_SETTERMINATIONTIME_RESOURCEUNKNOWNFAULT,
    COUNTERPORTTYPE_SETTERMINATIONTIME_UNABLETOSETTERMINATIONTIMEFAULT

} CounterPortType_SetTerminationTime_fault_t;


/* qname for operation SetTerminationTime */

extern xsd_QName CounterPortType_SetTerminationTime_op_qname;



/* fault type declaration for the add operation */

typedef enum
{
    COUNTERPORTTYPE_ADD_NOFAULT = 0,
    COUNTERPORTTYPE_ADD_UNKNOWN_FAULT = 1

} CounterPortType_add_fault_t;


/* qname for operation add */

extern xsd_QName CounterPortType_add_op_qname;



/* fault type declaration for the createCounter operation */

typedef enum
{
    COUNTERPORTTYPE_CREATECOUNTER_NOFAULT = 0,
    COUNTERPORTTYPE_CREATECOUNTER_UNKNOWN_FAULT = 1

} CounterPortType_createCounter_fault_t;


/* qname for operation createCounter */

extern xsd_QName CounterPortType_createCounter_op_qname;


/* ResourceProperty element QNames */

extern xsd_QName CounterPortType_Value_rp_qname;
extern struct globus_xsd_type_info_s CounterPortType_Value_rp_info;

extern xsd_QName CounterPortType_Topic_rp_qname;
extern struct globus_xsd_type_info_s CounterPortType_Topic_rp_info;

extern xsd_QName CounterPortType_TopicExpressionDialects_rp_qname;
extern struct globus_xsd_type_info_s CounterPortType_TopicExpressionDialects_rp_info;

extern xsd_QName CounterPortType_TerminationTime_rp_qname;
extern struct globus_xsd_type_info_s CounterPortType_TerminationTime_rp_info;

extern xsd_QName CounterPortType_CurrentTime_rp_qname;
extern struct globus_xsd_type_info_s CounterPortType_CurrentTime_rp_info;

extern xsd_QName CounterPortType_FixedTopicSet_rp_qname;
extern struct globus_xsd_type_info_s CounterPortType_FixedTopicSet_rp_info;

    
EXTERN_C_END

#endif
