/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _DELEGATIONFACTORYSERVICE_CLIENT_H_
#define _DELEGATIONFACTORYSERVICE_CLIENT_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#include "DelegationFactoryService.h"
#include "wsa_EndpointReferenceType.h"
#include "globus_soap_message_attrs.h"

#define WSADDRESSING_NS "http://schemas.xmlsoap.org/ws/2004/03/addressing"

/**
 * @defgroup DelegationFactoryService_client DelegationFactoryService Client Bindings
 */

extern globus_module_descriptor_t DelegationFactoryService_i_module;
/**
 * Module descriptor for the client stubs bindings for the
 * DelegationFactoryService service.
 * @ingroup DelegationFactoryService_client
 * @hideinitializer
 *
 * This module must be activated before calling any functions in the DelegationFactoryService
 * client bindings API.
 */
#define DELEGATIONFACTORYSERVICE_MODULE (&DelegationFactoryService_i_module)

/**
 * @defgroup DelegationFactoryService_client_handle Client Handle Functions and Types
 * @ingroup DelegationFactoryService_client
 */

/**
 * Handle for the DelegationFactoryService client.
 * @ingroup DelegationFactoryService_client_handle
 *
 * A handle must be created by the client application before calling any
 * SOAP operation. Only one operation may be in progress per handle at
 * any given time.
 *
 * @see DelegationFactoryService_client_init(), DelegationFactoryService_client_destroy()
 */
typedef struct DelegationFactoryService_client_handle_s * DelegationFactoryService_client_handle_t;



/* Type and function declarations for the GetResourceProperty
 * operation
 */

/**
 * @defgroup DelegationFactoryPortType_GetResourceProperty_operation GetResourceProperty Operation
 * @ingroup DelegationFactoryService_client
 *
 * The functions and types in this group are used by clients which will
 * be making GetResourceProperty requests of the DelegationFactoryService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * DelegationFactoryPortType_GetResourceProperty() and DelegationFactoryPortType_GetResourceProperty_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, DelegationFactoryPortType_GetResourceProperty_register() and
 * DelegationFactoryPortType_GetResourceProperty_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup DelegationFactoryPortType_GetResourceProperty_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>GetResourceProperty</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* DelegationFactoryPortType_GetResourceProperty_request_callback_func_t)(
    DelegationFactoryService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup DelegationFactoryPortType_GetResourceProperty_operation
 * Begin sending a request for the <code>GetResourceProperty</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_GetResourceProperty_epr_register_request(
    DelegationFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    DelegationFactoryPortType_GetResourceProperty_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup DelegationFactoryPortType_GetResourceProperty_operation
 * Begin sending a request for the <code>GetResourceProperty</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_GetResourceProperty_register_request(
    DelegationFactoryService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    DelegationFactoryPortType_GetResourceProperty_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup DelegationFactoryPortType_GetResourceProperty_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>GetResourceProperty</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* DelegationFactoryPortType_GetResourceProperty_response_callback_func_t)(
    DelegationFactoryService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_GetResourcePropertyResponseType * GetResourcePropertyResponse,
    DelegationFactoryPortType_GetResourceProperty_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup DelegationFactoryPortType_GetResourceProperty_operation
 * Begin parsing the request for the <code>GetResourceProperty</code> operation begun
 * by an earlier call to
 * DelegationFactoryPortType_GetResourceProperty_register_request() or
 * DelegationFactoryPortType_GetResourceProperty_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_GetResourceProperty_register_response(
    DelegationFactoryService_client_handle_t handle,
    DelegationFactoryPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup DelegationFactoryPortType_GetResourceProperty_operation
 *
 * Begin processing a request for the GetResourceProperty operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_GetResourceProperty_epr_register(
    DelegationFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    DelegationFactoryPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup DelegationFactoryPortType_GetResourceProperty_operation
 *
 * Begin processing a request for the GetResourceProperty operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_GetResourceProperty_register(
    DelegationFactoryService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    DelegationFactoryPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup DelegationFactoryPortType_GetResourceProperty_operation
 *
 * Request that an the GetResourceProperty operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetResourcePropertyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.

 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
DelegationFactoryPortType_GetResourceProperty_epr(
    DelegationFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    wsrp_GetResourcePropertyResponseType * * GetResourcePropertyResponse,
    DelegationFactoryPortType_GetResourceProperty_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup DelegationFactoryPortType_GetResourceProperty_operation
 *
 * Request that an the GetResourceProperty operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetResourcePropertyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.

 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
DelegationFactoryPortType_GetResourceProperty(
    DelegationFactoryService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    wsrp_GetResourcePropertyResponseType * * GetResourcePropertyResponse,
    DelegationFactoryPortType_GetResourceProperty_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the QueryResourceProperties
 * operation
 */

/**
 * @defgroup DelegationFactoryPortType_QueryResourceProperties_operation QueryResourceProperties Operation
 * @ingroup DelegationFactoryService_client
 *
 * The functions and types in this group are used by clients which will
 * be making QueryResourceProperties requests of the DelegationFactoryService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * DelegationFactoryPortType_QueryResourceProperties() and DelegationFactoryPortType_QueryResourceProperties_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, DelegationFactoryPortType_QueryResourceProperties_register() and
 * DelegationFactoryPortType_QueryResourceProperties_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup DelegationFactoryPortType_QueryResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>QueryResourceProperties</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* DelegationFactoryPortType_QueryResourceProperties_request_callback_func_t)(
    DelegationFactoryService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup DelegationFactoryPortType_QueryResourceProperties_operation
 * Begin sending a request for the <code>QueryResourceProperties</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_QueryResourceProperties_epr_register_request(
    DelegationFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    DelegationFactoryPortType_QueryResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup DelegationFactoryPortType_QueryResourceProperties_operation
 * Begin sending a request for the <code>QueryResourceProperties</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_QueryResourceProperties_register_request(
    DelegationFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    DelegationFactoryPortType_QueryResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup DelegationFactoryPortType_QueryResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>QueryResourceProperties</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param QueryResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* DelegationFactoryPortType_QueryResourceProperties_response_callback_func_t)(
    DelegationFactoryService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_QueryResourcePropertiesResponseType * QueryResourcePropertiesResponse,
    DelegationFactoryPortType_QueryResourceProperties_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup DelegationFactoryPortType_QueryResourceProperties_operation
 * Begin parsing the request for the <code>QueryResourceProperties</code> operation begun
 * by an earlier call to
 * DelegationFactoryPortType_QueryResourceProperties_register_request() or
 * DelegationFactoryPortType_QueryResourceProperties_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_QueryResourceProperties_register_response(
    DelegationFactoryService_client_handle_t handle,
    DelegationFactoryPortType_QueryResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup DelegationFactoryPortType_QueryResourceProperties_operation
 *
 * Begin processing a request for the QueryResourceProperties operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_QueryResourceProperties_epr_register(
    DelegationFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    DelegationFactoryPortType_QueryResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup DelegationFactoryPortType_QueryResourceProperties_operation
 *
 * Begin processing a request for the QueryResourceProperties operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_QueryResourceProperties_register(
    DelegationFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    DelegationFactoryPortType_QueryResourceProperties_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup DelegationFactoryPortType_QueryResourceProperties_operation
 *
 * Request that an the QueryResourceProperties operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a QueryResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param QueryResourceProperties
 *     Input parameter to the operation.

 * @param QueryResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
DelegationFactoryPortType_QueryResourceProperties_epr(
    DelegationFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    wsrp_QueryResourcePropertiesResponseType * * QueryResourcePropertiesResponse,
    DelegationFactoryPortType_QueryResourceProperties_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup DelegationFactoryPortType_QueryResourceProperties_operation
 *
 * Request that an the QueryResourceProperties operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a QueryResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param QueryResourceProperties
 *     Input parameter to the operation.

 * @param QueryResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
DelegationFactoryPortType_QueryResourceProperties(
    DelegationFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    wsrp_QueryResourcePropertiesResponseType * * QueryResourcePropertiesResponse,
    DelegationFactoryPortType_QueryResourceProperties_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the RequestSecurityToken2
 * operation
 */

/**
 * @defgroup DelegationFactoryPortType_RequestSecurityToken2_operation RequestSecurityToken2 Operation
 * @ingroup DelegationFactoryService_client
 *
 * The functions and types in this group are used by clients which will
 * be making RequestSecurityToken2 requests of the DelegationFactoryService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * DelegationFactoryPortType_RequestSecurityToken2() and DelegationFactoryPortType_RequestSecurityToken2_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, DelegationFactoryPortType_RequestSecurityToken2_register() and
 * DelegationFactoryPortType_RequestSecurityToken2_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup DelegationFactoryPortType_RequestSecurityToken2_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>RequestSecurityToken2</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* DelegationFactoryPortType_RequestSecurityToken2_request_callback_func_t)(
    DelegationFactoryService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup DelegationFactoryPortType_RequestSecurityToken2_operation
 * Begin sending a request for the <code>RequestSecurityToken2</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param RequestSecurityToken
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken2_epr_register_request(
    DelegationFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wst_RequestSecurityTokenType * RequestSecurityToken,
    DelegationFactoryPortType_RequestSecurityToken2_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup DelegationFactoryPortType_RequestSecurityToken2_operation
 * Begin sending a request for the <code>RequestSecurityToken2</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param RequestSecurityToken
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken2_register_request(
    DelegationFactoryService_client_handle_t handle,
    const char * endpoint,
    const wst_RequestSecurityTokenType * RequestSecurityToken,
    DelegationFactoryPortType_RequestSecurityToken2_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup DelegationFactoryPortType_RequestSecurityToken2_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>RequestSecurityToken2</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param RequestSecurityTokenResponseCollection
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* DelegationFactoryPortType_RequestSecurityToken2_response_callback_func_t)(
    DelegationFactoryService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wst_RequestSecurityTokenResponseCollectionType * RequestSecurityTokenResponseCollection,
    DelegationFactoryPortType_RequestSecurityToken2_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup DelegationFactoryPortType_RequestSecurityToken2_operation
 * Begin parsing the request for the <code>RequestSecurityToken2</code> operation begun
 * by an earlier call to
 * DelegationFactoryPortType_RequestSecurityToken2_register_request() or
 * DelegationFactoryPortType_RequestSecurityToken2_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken2_register_response(
    DelegationFactoryService_client_handle_t handle,
    DelegationFactoryPortType_RequestSecurityToken2_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup DelegationFactoryPortType_RequestSecurityToken2_operation
 *
 * Begin processing a request for the RequestSecurityToken2 operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param RequestSecurityToken
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken2_epr_register(
    DelegationFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wst_RequestSecurityTokenType * RequestSecurityToken,
    DelegationFactoryPortType_RequestSecurityToken2_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup DelegationFactoryPortType_RequestSecurityToken2_operation
 *
 * Begin processing a request for the RequestSecurityToken2 operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param RequestSecurityToken
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken2_register(
    DelegationFactoryService_client_handle_t handle,
    const char * endpoint,
    const wst_RequestSecurityTokenType * RequestSecurityToken,
    DelegationFactoryPortType_RequestSecurityToken2_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup DelegationFactoryPortType_RequestSecurityToken2_operation
 *
 * Request that an the RequestSecurityToken2 operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a RequestSecurityTokenResponseCollection parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param RequestSecurityToken
 *     Input parameter to the operation.

 * @param RequestSecurityTokenResponseCollection
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken2_epr(
    DelegationFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wst_RequestSecurityTokenType * RequestSecurityToken,
    wst_RequestSecurityTokenResponseCollectionType * * RequestSecurityTokenResponseCollection,
    DelegationFactoryPortType_RequestSecurityToken2_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup DelegationFactoryPortType_RequestSecurityToken2_operation
 *
 * Request that an the RequestSecurityToken2 operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a RequestSecurityTokenResponseCollection parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param RequestSecurityToken
 *     Input parameter to the operation.

 * @param RequestSecurityTokenResponseCollection
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken2(
    DelegationFactoryService_client_handle_t handle,
    const char * endpoint,
    const wst_RequestSecurityTokenType * RequestSecurityToken,
    wst_RequestSecurityTokenResponseCollectionType * * RequestSecurityTokenResponseCollection,
    DelegationFactoryPortType_RequestSecurityToken2_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the RequestSecurityToken
 * operation
 */

/**
 * @defgroup DelegationFactoryPortType_RequestSecurityToken_operation RequestSecurityToken Operation
 * @ingroup DelegationFactoryService_client
 *
 * The functions and types in this group are used by clients which will
 * be making RequestSecurityToken requests of the DelegationFactoryService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * DelegationFactoryPortType_RequestSecurityToken() and DelegationFactoryPortType_RequestSecurityToken_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, DelegationFactoryPortType_RequestSecurityToken_register() and
 * DelegationFactoryPortType_RequestSecurityToken_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup DelegationFactoryPortType_RequestSecurityToken_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>RequestSecurityToken</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* DelegationFactoryPortType_RequestSecurityToken_request_callback_func_t)(
    DelegationFactoryService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup DelegationFactoryPortType_RequestSecurityToken_operation
 * Begin sending a request for the <code>RequestSecurityToken</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param RequestSecurityToken
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken_epr_register_request(
    DelegationFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wst_RequestSecurityTokenType * RequestSecurityToken,
    DelegationFactoryPortType_RequestSecurityToken_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup DelegationFactoryPortType_RequestSecurityToken_operation
 * Begin sending a request for the <code>RequestSecurityToken</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param RequestSecurityToken
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken_register_request(
    DelegationFactoryService_client_handle_t handle,
    const char * endpoint,
    const wst_RequestSecurityTokenType * RequestSecurityToken,
    DelegationFactoryPortType_RequestSecurityToken_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup DelegationFactoryPortType_RequestSecurityToken_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>RequestSecurityToken</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param RequestSecurityTokenResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* DelegationFactoryPortType_RequestSecurityToken_response_callback_func_t)(
    DelegationFactoryService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wst_RequestSecurityTokenResponseType * RequestSecurityTokenResponse,
    DelegationFactoryPortType_RequestSecurityToken_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup DelegationFactoryPortType_RequestSecurityToken_operation
 * Begin parsing the request for the <code>RequestSecurityToken</code> operation begun
 * by an earlier call to
 * DelegationFactoryPortType_RequestSecurityToken_register_request() or
 * DelegationFactoryPortType_RequestSecurityToken_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken_register_response(
    DelegationFactoryService_client_handle_t handle,
    DelegationFactoryPortType_RequestSecurityToken_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup DelegationFactoryPortType_RequestSecurityToken_operation
 *
 * Begin processing a request for the RequestSecurityToken operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param RequestSecurityToken
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken_epr_register(
    DelegationFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wst_RequestSecurityTokenType * RequestSecurityToken,
    DelegationFactoryPortType_RequestSecurityToken_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup DelegationFactoryPortType_RequestSecurityToken_operation
 *
 * Begin processing a request for the RequestSecurityToken operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param RequestSecurityToken
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken_register(
    DelegationFactoryService_client_handle_t handle,
    const char * endpoint,
    const wst_RequestSecurityTokenType * RequestSecurityToken,
    DelegationFactoryPortType_RequestSecurityToken_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup DelegationFactoryPortType_RequestSecurityToken_operation
 *
 * Request that an the RequestSecurityToken operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a RequestSecurityTokenResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param RequestSecurityToken
 *     Input parameter to the operation.

 * @param RequestSecurityTokenResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken_epr(
    DelegationFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wst_RequestSecurityTokenType * RequestSecurityToken,
    wst_RequestSecurityTokenResponseType * * RequestSecurityTokenResponse,
    DelegationFactoryPortType_RequestSecurityToken_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup DelegationFactoryPortType_RequestSecurityToken_operation
 *
 * Request that an the RequestSecurityToken operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a RequestSecurityTokenResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #DelegationFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param RequestSecurityToken
 *     Input parameter to the operation.

 * @param RequestSecurityTokenResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
DelegationFactoryPortType_RequestSecurityToken(
    DelegationFactoryService_client_handle_t handle,
    const char * endpoint,
    const wst_RequestSecurityTokenType * RequestSecurityToken,
    wst_RequestSecurityTokenResponseType * * RequestSecurityTokenResponse,
    DelegationFactoryPortType_RequestSecurityToken_fault_t * fault_type,
    xsd_any * * fault);



/**
 * Initialize a client handle
 * @ingroup DelegationFactoryService_client_handle
 * Initialize new client handle state for use with operation-related functions.
 *
 * @param handle
 *     Pointer to the handle to initialize.
 * @param attrs
 *    Default attributes to use with this handle. This parameter may be NULL.
 *    Certain atttributes may cause different handlers to be pushed onto the
 *    default handler chain for this client.
 * @param handlers
 *    Handle chain to use with this handle. This parameter may be NULL.
 *    Typically the default handler chain used by this function is sufficient.
 */
globus_result_t
DelegationFactoryService_client_init(
    DelegationFactoryService_client_handle_t *  handle,
    globus_soap_message_attr_t attrs,
    globus_handler_chain_t handlers);

/**
 * Destroy a client handle
 * @ingroup DelegationFactoryService_client_handle
 *
 * Destroys the state associated with this client handle.
 *
 * @param handle
 *     Handle to destroy.
 */
void
DelegationFactoryService_client_destroy(
    DelegationFactoryService_client_handle_t handle);

/**
 * Cancel the current operation associated with this handle.
 * @ingroup DelegationFactoryService_client_handle
 * 
 * @param handle
 *     Handle which has the operation to cancel.
 */
globus_result_t
DelegationFactoryService_client_operation_cancel(
    DelegationFactoryService_client_handle_t handle);

/**
 * Get handle's type registry
 * @ingroup DelegationFactoryService_client_handle
 *
 * The type registry maps XML element names to type information structures.
 * Applications may wish to get the registry from a handle to set extra
 * type mappings (for example, to set a mapping for an element which is
 * to be received as part of an extensibility element).
 *
 * @param handle
 *     The handle to query.
 * @param registry
 *     A pointer to a registry handle which will be set to the handle's
 *     registry.
 */
globus_result_t
DelegationFactoryService_client_get_registry(
    DelegationFactoryService_client_handle_t handle,
    globus_xsd_type_registry_t * registry);

/**
 * Get handle's handler chain
 * @ingroup DelegationFactoryService_client_handle
 *
 * The handler chain contains information about which handlers (typically
 * SOAP header processors) will be invoked when a request is sent or a
 * response is received. Applications which want to add custom handlers at
 * run time may wish to push additional handlers onto this chain.
 *
 * @param handle
 *     The handle to query.
 * @param handlers
 *     A pointer to a handler chain which will be set to the handle's
 *     chain.
 */
globus_result_t
DelegationFactoryService_client_get_handler_chain(
    DelegationFactoryService_client_handle_t handle,
    globus_handler_chain_t * handlers);

/**
 * Set a SOAP attribute on a handle
 * @ingroup DelegationFactoryService_client_handle
 *
 * Set a SOAP attribute on a handle. This can be used to change how
 * the SOAP engine will process operations sent via this handle.
 *
 * @param handle
 *     The handle to modify.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * @param copy
 *     A function to copy the value. This is required if @a value will go
 *     out of scope.
 * @param destroy
 *     A function to destroy a copy of the value. Required if @a copy is set.
 * @param value
 *     The new value of the attribute.
 */
globus_result_t
DelegationFactoryService_client_attr_set(
    DelegationFactoryService_client_handle_t handle,
    const char * prop_name,
    globus_soap_message_attr_copy_func_t copy,
    globus_soap_message_attr_destroy_func_t destroy,
    void * value);

/**
 * Remove a SOAP attribute from a handle
 * @ingroup DelegationFactoryService_client_handle
 *
 * Remove a SOAP attribute on a handle. This can be used to change how
 * the SOAP engine will process operations sent via this handle.
 *
 * @param handle
 *     The handle to modify.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * 
 * @return
 *     This function returns the current value of the attribute.
 */
void *
DelegationFactoryService_client_attr_remove(
    DelegationFactoryService_client_handle_t handle,
    const char * prop_name);

/**
 * Get a SOAP attribute from a handle
 * @ingroup DelegationFactoryService_client_handle
 *
 * Get the current value of a SOAP attribute set on a handle. 
 *
 * @param handle
 *     The handle to query.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * 
 * @return
 *     This function returns the current value of the attribute.
 */
void *
DelegationFactoryService_client_attr_get(
    DelegationFactoryService_client_handle_t handle,
    const char * prop_name);

EXTERN_C_END

#endif
