/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _RENDEZVOUSFACTORYSERVICE_CLIENT_H_
#define _RENDEZVOUSFACTORYSERVICE_CLIENT_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#include "RendezvousFactoryService.h"
#include "wsa_EndpointReferenceType.h"
#include "globus_soap_message_attrs.h"

#define WSADDRESSING_NS "http://schemas.xmlsoap.org/ws/2004/03/addressing"

/**
 * @defgroup RendezvousFactoryService_client RendezvousFactoryService Client Bindings
 */

extern globus_module_descriptor_t RendezvousFactoryService_i_module;
/**
 * Module descriptor for the client stubs bindings for the
 * RendezvousFactoryService service.
 * @ingroup RendezvousFactoryService_client
 * @hideinitializer
 *
 * This module must be activated before calling any functions in the RendezvousFactoryService
 * client bindings API.
 */
#define RENDEZVOUSFACTORYSERVICE_MODULE (&RendezvousFactoryService_i_module)

/**
 * @defgroup RendezvousFactoryService_client_handle Client Handle Functions and Types
 * @ingroup RendezvousFactoryService_client
 */

/**
 * Handle for the RendezvousFactoryService client.
 * @ingroup RendezvousFactoryService_client_handle
 *
 * A handle must be created by the client application before calling any
 * SOAP operation. Only one operation may be in progress per handle at
 * any given time.
 *
 * @see RendezvousFactoryService_client_init(), RendezvousFactoryService_client_destroy()
 */
typedef struct RendezvousFactoryService_client_handle_s * RendezvousFactoryService_client_handle_t;



/* Type and function declarations for the GetCurrentMessage
 * operation
 */

/**
 * @defgroup RendezvousFactoryPortType_GetCurrentMessage_operation GetCurrentMessage Operation
 * @ingroup RendezvousFactoryService_client
 *
 * The functions and types in this group are used by clients which will
 * be making GetCurrentMessage requests of the RendezvousFactoryService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * RendezvousFactoryPortType_GetCurrentMessage() and RendezvousFactoryPortType_GetCurrentMessage_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, RendezvousFactoryPortType_GetCurrentMessage_register() and
 * RendezvousFactoryPortType_GetCurrentMessage_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup RendezvousFactoryPortType_GetCurrentMessage_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>GetCurrentMessage</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* RendezvousFactoryPortType_GetCurrentMessage_request_callback_func_t)(
    RendezvousFactoryService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup RendezvousFactoryPortType_GetCurrentMessage_operation
 * Begin sending a request for the <code>GetCurrentMessage</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetCurrentMessage
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_GetCurrentMessage_epr_register_request(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_GetCurrentMessageType * GetCurrentMessage,
    RendezvousFactoryPortType_GetCurrentMessage_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup RendezvousFactoryPortType_GetCurrentMessage_operation
 * Begin sending a request for the <code>GetCurrentMessage</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetCurrentMessage
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_GetCurrentMessage_register_request(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsnt_GetCurrentMessageType * GetCurrentMessage,
    RendezvousFactoryPortType_GetCurrentMessage_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup RendezvousFactoryPortType_GetCurrentMessage_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>GetCurrentMessage</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param GetCurrentMessageResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* RendezvousFactoryPortType_GetCurrentMessage_response_callback_func_t)(
    RendezvousFactoryService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsnt_GetCurrentMessageResponseType * GetCurrentMessageResponse,
    RendezvousFactoryPortType_GetCurrentMessage_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup RendezvousFactoryPortType_GetCurrentMessage_operation
 * Begin parsing the request for the <code>GetCurrentMessage</code> operation begun
 * by an earlier call to
 * RendezvousFactoryPortType_GetCurrentMessage_register_request() or
 * RendezvousFactoryPortType_GetCurrentMessage_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_GetCurrentMessage_register_response(
    RendezvousFactoryService_client_handle_t handle,
    RendezvousFactoryPortType_GetCurrentMessage_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup RendezvousFactoryPortType_GetCurrentMessage_operation
 *
 * Begin processing a request for the GetCurrentMessage operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetCurrentMessage
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_GetCurrentMessage_epr_register(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_GetCurrentMessageType * GetCurrentMessage,
    RendezvousFactoryPortType_GetCurrentMessage_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup RendezvousFactoryPortType_GetCurrentMessage_operation
 *
 * Begin processing a request for the GetCurrentMessage operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetCurrentMessage
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_GetCurrentMessage_register(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsnt_GetCurrentMessageType * GetCurrentMessage,
    RendezvousFactoryPortType_GetCurrentMessage_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup RendezvousFactoryPortType_GetCurrentMessage_operation
 *
 * Request that an the GetCurrentMessage operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetCurrentMessageResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetCurrentMessage
 *     Input parameter to the operation.

 * @param GetCurrentMessageResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
RendezvousFactoryPortType_GetCurrentMessage_epr(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_GetCurrentMessageType * GetCurrentMessage,
    wsnt_GetCurrentMessageResponseType * * GetCurrentMessageResponse,
    RendezvousFactoryPortType_GetCurrentMessage_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup RendezvousFactoryPortType_GetCurrentMessage_operation
 *
 * Request that an the GetCurrentMessage operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetCurrentMessageResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetCurrentMessage
 *     Input parameter to the operation.

 * @param GetCurrentMessageResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
RendezvousFactoryPortType_GetCurrentMessage(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsnt_GetCurrentMessageType * GetCurrentMessage,
    wsnt_GetCurrentMessageResponseType * * GetCurrentMessageResponse,
    RendezvousFactoryPortType_GetCurrentMessage_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the Subscribe
 * operation
 */

/**
 * @defgroup RendezvousFactoryPortType_Subscribe_operation Subscribe Operation
 * @ingroup RendezvousFactoryService_client
 *
 * The functions and types in this group are used by clients which will
 * be making Subscribe requests of the RendezvousFactoryService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * RendezvousFactoryPortType_Subscribe() and RendezvousFactoryPortType_Subscribe_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, RendezvousFactoryPortType_Subscribe_register() and
 * RendezvousFactoryPortType_Subscribe_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup RendezvousFactoryPortType_Subscribe_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>Subscribe</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* RendezvousFactoryPortType_Subscribe_request_callback_func_t)(
    RendezvousFactoryService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup RendezvousFactoryPortType_Subscribe_operation
 * Begin sending a request for the <code>Subscribe</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Subscribe
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_Subscribe_epr_register_request(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_SubscribeType * Subscribe,
    RendezvousFactoryPortType_Subscribe_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup RendezvousFactoryPortType_Subscribe_operation
 * Begin sending a request for the <code>Subscribe</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Subscribe
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_Subscribe_register_request(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsnt_SubscribeType * Subscribe,
    RendezvousFactoryPortType_Subscribe_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup RendezvousFactoryPortType_Subscribe_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>Subscribe</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param SubscribeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* RendezvousFactoryPortType_Subscribe_response_callback_func_t)(
    RendezvousFactoryService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsnt_SubscribeResponseType * SubscribeResponse,
    RendezvousFactoryPortType_Subscribe_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup RendezvousFactoryPortType_Subscribe_operation
 * Begin parsing the request for the <code>Subscribe</code> operation begun
 * by an earlier call to
 * RendezvousFactoryPortType_Subscribe_register_request() or
 * RendezvousFactoryPortType_Subscribe_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_Subscribe_register_response(
    RendezvousFactoryService_client_handle_t handle,
    RendezvousFactoryPortType_Subscribe_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup RendezvousFactoryPortType_Subscribe_operation
 *
 * Begin processing a request for the Subscribe operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Subscribe
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_Subscribe_epr_register(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_SubscribeType * Subscribe,
    RendezvousFactoryPortType_Subscribe_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup RendezvousFactoryPortType_Subscribe_operation
 *
 * Begin processing a request for the Subscribe operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Subscribe
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_Subscribe_register(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsnt_SubscribeType * Subscribe,
    RendezvousFactoryPortType_Subscribe_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup RendezvousFactoryPortType_Subscribe_operation
 *
 * Request that an the Subscribe operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a SubscribeResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Subscribe
 *     Input parameter to the operation.

 * @param SubscribeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
RendezvousFactoryPortType_Subscribe_epr(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsnt_SubscribeType * Subscribe,
    wsnt_SubscribeResponseType * * SubscribeResponse,
    RendezvousFactoryPortType_Subscribe_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup RendezvousFactoryPortType_Subscribe_operation
 *
 * Request that an the Subscribe operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a SubscribeResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Subscribe
 *     Input parameter to the operation.

 * @param SubscribeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
RendezvousFactoryPortType_Subscribe(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsnt_SubscribeType * Subscribe,
    wsnt_SubscribeResponseType * * SubscribeResponse,
    RendezvousFactoryPortType_Subscribe_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the GetResourceProperty
 * operation
 */

/**
 * @defgroup RendezvousFactoryPortType_GetResourceProperty_operation GetResourceProperty Operation
 * @ingroup RendezvousFactoryService_client
 *
 * The functions and types in this group are used by clients which will
 * be making GetResourceProperty requests of the RendezvousFactoryService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * RendezvousFactoryPortType_GetResourceProperty() and RendezvousFactoryPortType_GetResourceProperty_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, RendezvousFactoryPortType_GetResourceProperty_register() and
 * RendezvousFactoryPortType_GetResourceProperty_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup RendezvousFactoryPortType_GetResourceProperty_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>GetResourceProperty</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* RendezvousFactoryPortType_GetResourceProperty_request_callback_func_t)(
    RendezvousFactoryService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup RendezvousFactoryPortType_GetResourceProperty_operation
 * Begin sending a request for the <code>GetResourceProperty</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_GetResourceProperty_epr_register_request(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    RendezvousFactoryPortType_GetResourceProperty_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup RendezvousFactoryPortType_GetResourceProperty_operation
 * Begin sending a request for the <code>GetResourceProperty</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_GetResourceProperty_register_request(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    RendezvousFactoryPortType_GetResourceProperty_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup RendezvousFactoryPortType_GetResourceProperty_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>GetResourceProperty</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* RendezvousFactoryPortType_GetResourceProperty_response_callback_func_t)(
    RendezvousFactoryService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_GetResourcePropertyResponseType * GetResourcePropertyResponse,
    RendezvousFactoryPortType_GetResourceProperty_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup RendezvousFactoryPortType_GetResourceProperty_operation
 * Begin parsing the request for the <code>GetResourceProperty</code> operation begun
 * by an earlier call to
 * RendezvousFactoryPortType_GetResourceProperty_register_request() or
 * RendezvousFactoryPortType_GetResourceProperty_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_GetResourceProperty_register_response(
    RendezvousFactoryService_client_handle_t handle,
    RendezvousFactoryPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup RendezvousFactoryPortType_GetResourceProperty_operation
 *
 * Begin processing a request for the GetResourceProperty operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_GetResourceProperty_epr_register(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    RendezvousFactoryPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup RendezvousFactoryPortType_GetResourceProperty_operation
 *
 * Begin processing a request for the GetResourceProperty operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_GetResourceProperty_register(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    RendezvousFactoryPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup RendezvousFactoryPortType_GetResourceProperty_operation
 *
 * Request that an the GetResourceProperty operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetResourcePropertyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.

 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
RendezvousFactoryPortType_GetResourceProperty_epr(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    wsrp_GetResourcePropertyResponseType * * GetResourcePropertyResponse,
    RendezvousFactoryPortType_GetResourceProperty_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup RendezvousFactoryPortType_GetResourceProperty_operation
 *
 * Request that an the GetResourceProperty operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetResourcePropertyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.

 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
RendezvousFactoryPortType_GetResourceProperty(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    wsrp_GetResourcePropertyResponseType * * GetResourcePropertyResponse,
    RendezvousFactoryPortType_GetResourceProperty_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the register
 * operation
 */

/**
 * @defgroup RendezvousFactoryPortType_register_operation register Operation
 * @ingroup RendezvousFactoryService_client
 *
 * The functions and types in this group are used by clients which will
 * be making register requests of the RendezvousFactoryService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * RendezvousFactoryPortType_register() and RendezvousFactoryPortType_register_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, RendezvousFactoryPortType_register_register() and
 * RendezvousFactoryPortType_register_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup RendezvousFactoryPortType_register_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>register</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* RendezvousFactoryPortType_register_request_callback_func_t)(
    RendezvousFactoryService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup RendezvousFactoryPortType_register_operation
 * Begin sending a request for the <code>register</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param registerInput
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_register_epr_register_request(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrendezvous_registerInputType * registerInput,
    RendezvousFactoryPortType_register_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup RendezvousFactoryPortType_register_operation
 * Begin sending a request for the <code>register</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param registerInput
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_register_register_request(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrendezvous_registerInputType * registerInput,
    RendezvousFactoryPortType_register_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup RendezvousFactoryPortType_register_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>register</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param registerResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* RendezvousFactoryPortType_register_response_callback_func_t)(
    RendezvousFactoryService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrendezvous_registerResponseType * registerResponse,
    RendezvousFactoryPortType_register_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup RendezvousFactoryPortType_register_operation
 * Begin parsing the request for the <code>register</code> operation begun
 * by an earlier call to
 * RendezvousFactoryPortType_register_register_request() or
 * RendezvousFactoryPortType_register_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_register_register_response(
    RendezvousFactoryService_client_handle_t handle,
    RendezvousFactoryPortType_register_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup RendezvousFactoryPortType_register_operation
 *
 * Begin processing a request for the register operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param registerInput
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_register_epr_register(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrendezvous_registerInputType * registerInput,
    RendezvousFactoryPortType_register_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup RendezvousFactoryPortType_register_operation
 *
 * Begin processing a request for the register operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param registerInput
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_register_register(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrendezvous_registerInputType * registerInput,
    RendezvousFactoryPortType_register_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup RendezvousFactoryPortType_register_operation
 *
 * Request that an the register operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a registerResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param registerInput
 *     Input parameter to the operation.

 * @param registerResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
RendezvousFactoryPortType_register_epr(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrendezvous_registerInputType * registerInput,
    wsrendezvous_registerResponseType * * registerResponse,
    RendezvousFactoryPortType_register_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup RendezvousFactoryPortType_register_operation
 *
 * Request that an the register operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a registerResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param registerInput
 *     Input parameter to the operation.

 * @param registerResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
RendezvousFactoryPortType_register(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrendezvous_registerInputType * registerInput,
    wsrendezvous_registerResponseType * * registerResponse,
    RendezvousFactoryPortType_register_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the createSync
 * operation
 */

/**
 * @defgroup RendezvousFactoryPortType_createSync_operation createSync Operation
 * @ingroup RendezvousFactoryService_client
 *
 * The functions and types in this group are used by clients which will
 * be making createSync requests of the RendezvousFactoryService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * RendezvousFactoryPortType_createSync() and RendezvousFactoryPortType_createSync_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, RendezvousFactoryPortType_createSync_register() and
 * RendezvousFactoryPortType_createSync_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup RendezvousFactoryPortType_createSync_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>createSync</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* RendezvousFactoryPortType_createSync_request_callback_func_t)(
    RendezvousFactoryService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup RendezvousFactoryPortType_createSync_operation
 * Begin sending a request for the <code>createSync</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param createSync
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_createSync_epr_register_request(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrendezvous_createSyncType * createSync,
    RendezvousFactoryPortType_createSync_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup RendezvousFactoryPortType_createSync_operation
 * Begin sending a request for the <code>createSync</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param createSync
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_createSync_register_request(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrendezvous_createSyncType * createSync,
    RendezvousFactoryPortType_createSync_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup RendezvousFactoryPortType_createSync_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>createSync</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param createSyncResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* RendezvousFactoryPortType_createSync_response_callback_func_t)(
    RendezvousFactoryService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrendezvous_createSyncResponseType * createSyncResponse,
    RendezvousFactoryPortType_createSync_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup RendezvousFactoryPortType_createSync_operation
 * Begin parsing the request for the <code>createSync</code> operation begun
 * by an earlier call to
 * RendezvousFactoryPortType_createSync_register_request() or
 * RendezvousFactoryPortType_createSync_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_createSync_register_response(
    RendezvousFactoryService_client_handle_t handle,
    RendezvousFactoryPortType_createSync_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup RendezvousFactoryPortType_createSync_operation
 *
 * Begin processing a request for the createSync operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param createSync
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_createSync_epr_register(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrendezvous_createSyncType * createSync,
    RendezvousFactoryPortType_createSync_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup RendezvousFactoryPortType_createSync_operation
 *
 * Begin processing a request for the createSync operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param createSync
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
RendezvousFactoryPortType_createSync_register(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrendezvous_createSyncType * createSync,
    RendezvousFactoryPortType_createSync_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup RendezvousFactoryPortType_createSync_operation
 *
 * Request that an the createSync operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a createSyncResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param createSync
 *     Input parameter to the operation.

 * @param createSyncResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
RendezvousFactoryPortType_createSync_epr(
    RendezvousFactoryService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrendezvous_createSyncType * createSync,
    wsrendezvous_createSyncResponseType * * createSyncResponse,
    RendezvousFactoryPortType_createSync_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup RendezvousFactoryPortType_createSync_operation
 *
 * Request that an the createSync operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a createSyncResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #RendezvousFactoryService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param createSync
 *     Input parameter to the operation.

 * @param createSyncResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
RendezvousFactoryPortType_createSync(
    RendezvousFactoryService_client_handle_t handle,
    const char * endpoint,
    const wsrendezvous_createSyncType * createSync,
    wsrendezvous_createSyncResponseType * * createSyncResponse,
    RendezvousFactoryPortType_createSync_fault_t * fault_type,
    xsd_any * * fault);



/**
 * Initialize a client handle
 * @ingroup RendezvousFactoryService_client_handle
 * Initialize new client handle state for use with operation-related functions.
 *
 * @param handle
 *     Pointer to the handle to initialize.
 * @param attrs
 *    Default attributes to use with this handle. This parameter may be NULL.
 *    Certain atttributes may cause different handlers to be pushed onto the
 *    default handler chain for this client.
 * @param handlers
 *    Handle chain to use with this handle. This parameter may be NULL.
 *    Typically the default handler chain used by this function is sufficient.
 */
globus_result_t
RendezvousFactoryService_client_init(
    RendezvousFactoryService_client_handle_t *  handle,
    globus_soap_message_attr_t attrs,
    globus_handler_chain_t handlers);

/**
 * Destroy a client handle
 * @ingroup RendezvousFactoryService_client_handle
 *
 * Destroys the state associated with this client handle.
 *
 * @param handle
 *     Handle to destroy.
 */
void
RendezvousFactoryService_client_destroy(
    RendezvousFactoryService_client_handle_t handle);

/**
 * Cancel the current operation associated with this handle.
 * @ingroup RendezvousFactoryService_client_handle
 * 
 * @param handle
 *     Handle which has the operation to cancel.
 */
globus_result_t
RendezvousFactoryService_client_operation_cancel(
    RendezvousFactoryService_client_handle_t handle);

/**
 * Get handle's type registry
 * @ingroup RendezvousFactoryService_client_handle
 *
 * The type registry maps XML element names to type information structures.
 * Applications may wish to get the registry from a handle to set extra
 * type mappings (for example, to set a mapping for an element which is
 * to be received as part of an extensibility element).
 *
 * @param handle
 *     The handle to query.
 * @param registry
 *     A pointer to a registry handle which will be set to the handle's
 *     registry.
 */
globus_result_t
RendezvousFactoryService_client_get_registry(
    RendezvousFactoryService_client_handle_t handle,
    globus_xsd_type_registry_t * registry);

/**
 * Get handle's handler chain
 * @ingroup RendezvousFactoryService_client_handle
 *
 * The handler chain contains information about which handlers (typically
 * SOAP header processors) will be invoked when a request is sent or a
 * response is received. Applications which want to add custom handlers at
 * run time may wish to push additional handlers onto this chain.
 *
 * @param handle
 *     The handle to query.
 * @param handlers
 *     A pointer to a handler chain which will be set to the handle's
 *     chain.
 */
globus_result_t
RendezvousFactoryService_client_get_handler_chain(
    RendezvousFactoryService_client_handle_t handle,
    globus_handler_chain_t * handlers);

/**
 * Set a SOAP attribute on a handle
 * @ingroup RendezvousFactoryService_client_handle
 *
 * Set a SOAP attribute on a handle. This can be used to change how
 * the SOAP engine will process operations sent via this handle.
 *
 * @param handle
 *     The handle to modify.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * @param copy
 *     A function to copy the value. This is required if @a value will go
 *     out of scope.
 * @param destroy
 *     A function to destroy a copy of the value. Required if @a copy is set.
 * @param value
 *     The new value of the attribute.
 */
globus_result_t
RendezvousFactoryService_client_attr_set(
    RendezvousFactoryService_client_handle_t handle,
    const char * prop_name,
    globus_soap_message_attr_copy_func_t copy,
    globus_soap_message_attr_destroy_func_t destroy,
    void * value);

/**
 * Remove a SOAP attribute from a handle
 * @ingroup RendezvousFactoryService_client_handle
 *
 * Remove a SOAP attribute on a handle. This can be used to change how
 * the SOAP engine will process operations sent via this handle.
 *
 * @param handle
 *     The handle to modify.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * 
 * @return
 *     This function returns the current value of the attribute.
 */
void *
RendezvousFactoryService_client_attr_remove(
    RendezvousFactoryService_client_handle_t handle,
    const char * prop_name);

/**
 * Get a SOAP attribute from a handle
 * @ingroup RendezvousFactoryService_client_handle
 *
 * Get the current value of a SOAP attribute set on a handle. 
 *
 * @param handle
 *     The handle to query.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * 
 * @return
 *     This function returns the current value of the attribute.
 */
void *
RendezvousFactoryService_client_attr_get(
    RendezvousFactoryService_client_handle_t handle,
    const char * prop_name);

EXTERN_C_END

#endif
