/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC convert
 */

#ifndef _RENDEZVOUSSERVICE_H_
#define _RENDEZVOUSSERVICE_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#include "globus_handler.h"
#include "globus_soap_message.h"
#include "globus_xsd_type_registry.h"

#define RENDEZVOUSSERVICE_BASE_PATH "wsrf/services/RendezvousService"

extern xsd_QName RendezvousService_service_qname;

globus_result_t
RendezvousService_registry_add_types(
    globus_xsd_type_registry_t          registry);

globus_result_t
RendezvousService_registry_remove_types(
    globus_xsd_type_registry_t          registry);


#include "wsnt_GetCurrentMessageType.h"
#include "wsnt_GetCurrentMessageResponseType.h"
#include "wsnt_ResourceUnknownFaultType.h"
#include "wsnt_ResourceUnknownFault.h"
#include "wsnt_NoCurrentMessageOnTopicFaultType.h"
#include "wsnt_NoCurrentMessageOnTopicFault.h"
#include "wsnt_InvalidTopicExpressionFaultType.h"
#include "wsnt_InvalidTopicExpressionFault.h"
#include "wsnt_TopicNotSupportedFaultType.h"
#include "wsnt_TopicNotSupportedFault.h"
#include "wsnt_SubscribeType.h"
#include "wsnt_SubscribeResponseType.h"
#include "wsnt_TopicPathDialectUnknownFaultType.h"
#include "wsnt_TopicPathDialectUnknownFault.h"
#include "wsnt_ResourceUnknownFaultType.h"
#include "wsnt_ResourceUnknownFault.h"
#include "wsnt_SubscribeCreationFailedFaultType.h"
#include "wsnt_SubscribeCreationFailedFault.h"
#include "wsnt_InvalidTopicExpressionFaultType.h"
#include "wsnt_InvalidTopicExpressionFault.h"
#include "wsnt_TopicNotSupportedFaultType.h"
#include "wsnt_TopicNotSupportedFault.h"
#include "xsd_QName.h"
#include "wsrp_GetResourcePropertyResponseType.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrendezvous_registerInputType.h"
#include "wsrendezvous_registerResponseType.h"
#include "wsrendezvous_CapacityReachedFaultType.h"
#include "wsrendezvous_capacityReachedFault.h"
#include "wsrendezvous_RankTakenFaultType.h"
#include "wsrendezvous_rankTakenFault.h"

/* fault type declaration for the GetCurrentMessage operation */

typedef enum
{
    RENDEZVOUSPORTTYPE_GETCURRENTMESSAGE_NOFAULT = 0,
    RENDEZVOUSPORTTYPE_GETCURRENTMESSAGE_UNKNOWN_FAULT = 1,
    RENDEZVOUSPORTTYPE_GETCURRENTMESSAGE_RESOURCEUNKNOWNFAULT,
    RENDEZVOUSPORTTYPE_GETCURRENTMESSAGE_NOCURRENTMESSAGEONTOPICFAULT,
    RENDEZVOUSPORTTYPE_GETCURRENTMESSAGE_INVALIDTOPICEXPRESSIONFAULT,
    RENDEZVOUSPORTTYPE_GETCURRENTMESSAGE_TOPICNOTSUPPORTEDFAULT

} RendezvousPortType_GetCurrentMessage_fault_t;


/* qname for operation GetCurrentMessage */

extern xsd_QName RendezvousPortType_GetCurrentMessage_op_qname;



/* fault type declaration for the Subscribe operation */

typedef enum
{
    RENDEZVOUSPORTTYPE_SUBSCRIBE_NOFAULT = 0,
    RENDEZVOUSPORTTYPE_SUBSCRIBE_UNKNOWN_FAULT = 1,
    RENDEZVOUSPORTTYPE_SUBSCRIBE_TOPICPATHDIALECTUNKNOWNFAULT,
    RENDEZVOUSPORTTYPE_SUBSCRIBE_RESOURCEUNKNOWNFAULT,
    RENDEZVOUSPORTTYPE_SUBSCRIBE_SUBSCRIBECREATIONFAILEDFAULT,
    RENDEZVOUSPORTTYPE_SUBSCRIBE_INVALIDTOPICEXPRESSIONFAULT,
    RENDEZVOUSPORTTYPE_SUBSCRIBE_TOPICNOTSUPPORTEDFAULT

} RendezvousPortType_Subscribe_fault_t;


/* qname for operation Subscribe */

extern xsd_QName RendezvousPortType_Subscribe_op_qname;



/* fault type declaration for the GetResourceProperty operation */

typedef enum
{
    RENDEZVOUSPORTTYPE_GETRESOURCEPROPERTY_NOFAULT = 0,
    RENDEZVOUSPORTTYPE_GETRESOURCEPROPERTY_UNKNOWN_FAULT = 1,
    RENDEZVOUSPORTTYPE_GETRESOURCEPROPERTY_RESOURCEUNKNOWNFAULT,
    RENDEZVOUSPORTTYPE_GETRESOURCEPROPERTY_INVALIDRESOURCEPROPERTYQNAMEFAULT

} RendezvousPortType_GetResourceProperty_fault_t;


/* qname for operation GetResourceProperty */

extern xsd_QName RendezvousPortType_GetResourceProperty_op_qname;



/* fault type declaration for the register operation */

typedef enum
{
    RENDEZVOUSPORTTYPE_REGISTER_NOFAULT = 0,
    RENDEZVOUSPORTTYPE_REGISTER_UNKNOWN_FAULT = 1,
    RENDEZVOUSPORTTYPE_REGISTER_CAPACITYREACHEDFAULT,
    RENDEZVOUSPORTTYPE_REGISTER_RANKTAKENFAULT

} RendezvousPortType_register_fault_t;


/* qname for operation register */

extern xsd_QName RendezvousPortType_register_op_qname;


/* ResourceProperty element QNames */

extern xsd_QName RendezvousPortType_RendezvousCompleted_rp_qname;
extern struct globus_xsd_type_info_s RendezvousPortType_RendezvousCompleted_rp_info;

extern xsd_QName RendezvousPortType_RegistrantData_rp_qname;
extern struct globus_xsd_type_info_s RendezvousPortType_RegistrantData_rp_info;

extern xsd_QName RendezvousPortType_Capacity_rp_qname;
extern struct globus_xsd_type_info_s RendezvousPortType_Capacity_rp_info;

extern xsd_QName RendezvousPortType_Topic_rp_qname;
extern struct globus_xsd_type_info_s RendezvousPortType_Topic_rp_info;

extern xsd_QName RendezvousPortType_TopicExpressionDialects_rp_qname;
extern struct globus_xsd_type_info_s RendezvousPortType_TopicExpressionDialects_rp_info;

extern xsd_QName RendezvousPortType_FixedTopicSet_rp_qname;
extern struct globus_xsd_type_info_s RendezvousPortType_FixedTopicSet_rp_info;

    
EXTERN_C_END

#endif
