/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC convert
 */

#ifndef _WIDGETSERVICE_H_
#define _WIDGETSERVICE_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#include "globus_handler.h"
#include "globus_soap_message.h"
#include "globus_xsd_type_registry.h"

#define WIDGETSERVICE_BASE_PATH "wsrf/services/WidgetService"

extern xsd_QName WidgetService_service_qname;

globus_result_t
WidgetService_registry_add_types(
    globus_xsd_type_registry_t          registry);

globus_result_t
WidgetService_registry_remove_types(
    globus_xsd_type_registry_t          registry);


#include "wsrl_SetTerminationTimeType.h"
#include "wsrl_SetTerminationTimeResponseType.h"
#include "wsrl_TerminationTimeChangeRejectedFaultType.h"
#include "wsrl_TerminationTimeChangeRejectedFault.h"
#include "wsrl_UnableToSetTerminationTimeFaultType.h"
#include "wsrl_UnableToSetTerminationTimeFault.h"
#include "wsrl_ResourceUnknownFaultType.h"
#include "wsrl_ResourceUnknownFault.h"
#include "wsrl_DestroyType.h"
#include "wsrl_DestroyResponseType.h"
#include "wsrl_ResourceNotDestroyedFaultType.h"
#include "wsrl_ResourceNotDestroyedFault.h"
#include "wsrl_ResourceUnknownFaultType.h"
#include "wsrl_ResourceUnknownFault.h"
#include "wsrp_QueryResourcePropertiesType.h"
#include "wsrp_QueryResourcePropertiesResponseType.h"
#include "wsrp_QueryEvaluationErrorFaultType.h"
#include "wsrp_QueryEvaluationErrorFault.h"
#include "wsrp_InvalidQueryExpressionFaultType.h"
#include "wsrp_InvalidQueryExpressionFault.h"
#include "wsrp_UnknownQueryExpressionDialectFaultType.h"
#include "wsrp_UnknownQueryExpressionDialectFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_SetResourcePropertiesType.h"
#include "wsrp_SetResourcePropertiesResponseType.h"
#include "wsrp_SetResourcePropertyRequestFailedFaultType.h"
#include "wsrp_SetResourcePropertyRequestFailedFault.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrp_UnableToModifyResourcePropertyFaultType.h"
#include "wsrp_UnableToModifyResourcePropertyFault.h"
#include "wsrp_InvalidSetResourcePropertiesRequestContentFaultType.h"
#include "wsrp_InvalidSetResourcePropertiesRequestContentFault.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "wsrp_GetMultipleResourcePropertiesType.h"
#include "wsrp_GetMultipleResourcePropertiesResponseType.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "xsd_QName.h"
#include "wsrp_GetResourcePropertyResponseType.h"
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"
#include "wsrp_InvalidResourcePropertyQNameFault.h"
#include "wsrp_ResourceUnknownFaultType.h"
#include "wsrp_ResourceUnknownFault.h"
#include "createWidgetType.h"
#include "createWidgetResponseType.h"

/* fault type declaration for the SetTerminationTime operation */

typedef enum
{
    WIDGETPORTTYPE_SETTERMINATIONTIME_NOFAULT = 0,
    WIDGETPORTTYPE_SETTERMINATIONTIME_UNKNOWN_FAULT = 1,
    WIDGETPORTTYPE_SETTERMINATIONTIME_TERMINATIONTIMECHANGEREJECTEDFAULT,
    WIDGETPORTTYPE_SETTERMINATIONTIME_UNABLETOSETTERMINATIONTIMEFAULT,
    WIDGETPORTTYPE_SETTERMINATIONTIME_RESOURCEUNKNOWNFAULT

} WidgetPortType_SetTerminationTime_fault_t;


/* qname for operation SetTerminationTime */

extern xsd_QName WidgetPortType_SetTerminationTime_op_qname;



/* fault type declaration for the Destroy operation */

typedef enum
{
    WIDGETPORTTYPE_DESTROY_NOFAULT = 0,
    WIDGETPORTTYPE_DESTROY_UNKNOWN_FAULT = 1,
    WIDGETPORTTYPE_DESTROY_RESOURCENOTDESTROYEDFAULT,
    WIDGETPORTTYPE_DESTROY_RESOURCEUNKNOWNFAULT

} WidgetPortType_Destroy_fault_t;


/* qname for operation Destroy */

extern xsd_QName WidgetPortType_Destroy_op_qname;



/* fault type declaration for the QueryResourceProperties operation */

typedef enum
{
    WIDGETPORTTYPE_QUERYRESOURCEPROPERTIES_NOFAULT = 0,
    WIDGETPORTTYPE_QUERYRESOURCEPROPERTIES_UNKNOWN_FAULT = 1,
    WIDGETPORTTYPE_QUERYRESOURCEPROPERTIES_QUERYEVALUATIONERRORFAULT,
    WIDGETPORTTYPE_QUERYRESOURCEPROPERTIES_INVALIDQUERYEXPRESSIONFAULT,
    WIDGETPORTTYPE_QUERYRESOURCEPROPERTIES_UNKNOWNQUERYEXPRESSIONDIALECTFAULT,
    WIDGETPORTTYPE_QUERYRESOURCEPROPERTIES_INVALIDRESOURCEPROPERTYQNAMEFAULT,
    WIDGETPORTTYPE_QUERYRESOURCEPROPERTIES_RESOURCEUNKNOWNFAULT

} WidgetPortType_QueryResourceProperties_fault_t;


/* qname for operation QueryResourceProperties */

extern xsd_QName WidgetPortType_QueryResourceProperties_op_qname;



/* fault type declaration for the SetResourceProperties operation */

typedef enum
{
    WIDGETPORTTYPE_SETRESOURCEPROPERTIES_NOFAULT = 0,
    WIDGETPORTTYPE_SETRESOURCEPROPERTIES_UNKNOWN_FAULT = 1,
    WIDGETPORTTYPE_SETRESOURCEPROPERTIES_SETRESOURCEPROPERTYREQUESTFAILEDFAULT,
    WIDGETPORTTYPE_SETRESOURCEPROPERTIES_INVALIDRESOURCEPROPERTYQNAMEFAULT,
    WIDGETPORTTYPE_SETRESOURCEPROPERTIES_UNABLETOMODIFYRESOURCEPROPERTYFAULT,
    WIDGETPORTTYPE_SETRESOURCEPROPERTIES_INVALIDSETRESOURCEPROPERTIESREQUESTCONTENTFAULT,
    WIDGETPORTTYPE_SETRESOURCEPROPERTIES_RESOURCEUNKNOWNFAULT

} WidgetPortType_SetResourceProperties_fault_t;


/* qname for operation SetResourceProperties */

extern xsd_QName WidgetPortType_SetResourceProperties_op_qname;



/* fault type declaration for the GetMultipleResourceProperties operation */

typedef enum
{
    WIDGETPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_NOFAULT = 0,
    WIDGETPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_UNKNOWN_FAULT = 1,
    WIDGETPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_INVALIDRESOURCEPROPERTYQNAMEFAULT,
    WIDGETPORTTYPE_GETMULTIPLERESOURCEPROPERTIES_RESOURCEUNKNOWNFAULT

} WidgetPortType_GetMultipleResourceProperties_fault_t;


/* qname for operation GetMultipleResourceProperties */

extern xsd_QName WidgetPortType_GetMultipleResourceProperties_op_qname;



/* fault type declaration for the GetResourceProperty operation */

typedef enum
{
    WIDGETPORTTYPE_GETRESOURCEPROPERTY_NOFAULT = 0,
    WIDGETPORTTYPE_GETRESOURCEPROPERTY_UNKNOWN_FAULT = 1,
    WIDGETPORTTYPE_GETRESOURCEPROPERTY_INVALIDRESOURCEPROPERTYQNAMEFAULT,
    WIDGETPORTTYPE_GETRESOURCEPROPERTY_RESOURCEUNKNOWNFAULT

} WidgetPortType_GetResourceProperty_fault_t;


/* qname for operation GetResourceProperty */

extern xsd_QName WidgetPortType_GetResourceProperty_op_qname;



/* fault type declaration for the createWidget operation */

typedef enum
{
    WIDGETPORTTYPE_CREATEWIDGET_NOFAULT = 0,
    WIDGETPORTTYPE_CREATEWIDGET_UNKNOWN_FAULT = 1

} WidgetPortType_createWidget_fault_t;


/* qname for operation createWidget */

extern xsd_QName WidgetPortType_createWidget_op_qname;


/* ResourceProperty element QNames */

    
EXTERN_C_END

#endif
