/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WIDGETSERVICE_CLIENT_H_
#define _WIDGETSERVICE_CLIENT_H_

#include "globus_common.h"

EXTERN_C_BEGIN

#include "WidgetService.h"
#include "wsa_EndpointReferenceType.h"
#include "globus_soap_message_attrs.h"

#define WSADDRESSING_NS "http://schemas.xmlsoap.org/ws/2004/03/addressing"

/**
 * @defgroup WidgetService_client WidgetService Client Bindings
 */

extern globus_module_descriptor_t WidgetService_i_module;
/**
 * Module descriptor for the client stubs bindings for the
 * WidgetService service.
 * @ingroup WidgetService_client
 * @hideinitializer
 *
 * This module must be activated before calling any functions in the WidgetService
 * client bindings API.
 */
#define WIDGETSERVICE_MODULE (&WidgetService_i_module)

/**
 * @defgroup WidgetService_client_handle Client Handle Functions and Types
 * @ingroup WidgetService_client
 */

/**
 * Handle for the WidgetService client.
 * @ingroup WidgetService_client_handle
 *
 * A handle must be created by the client application before calling any
 * SOAP operation. Only one operation may be in progress per handle at
 * any given time.
 *
 * @see WidgetService_client_init(), WidgetService_client_destroy()
 */
typedef struct WidgetService_client_handle_s * WidgetService_client_handle_t;



/* Type and function declarations for the SetTerminationTime
 * operation
 */

/**
 * @defgroup WidgetPortType_SetTerminationTime_operation SetTerminationTime Operation
 * @ingroup WidgetService_client
 *
 * The functions and types in this group are used by clients which will
 * be making SetTerminationTime requests of the WidgetService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * WidgetPortType_SetTerminationTime() and WidgetPortType_SetTerminationTime_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, WidgetPortType_SetTerminationTime_register() and
 * WidgetPortType_SetTerminationTime_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup WidgetPortType_SetTerminationTime_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>SetTerminationTime</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* WidgetPortType_SetTerminationTime_request_callback_func_t)(
    WidgetService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup WidgetPortType_SetTerminationTime_operation
 * Begin sending a request for the <code>SetTerminationTime</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param SetTerminationTime
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_SetTerminationTime_epr_register_request(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    WidgetPortType_SetTerminationTime_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup WidgetPortType_SetTerminationTime_operation
 * Begin sending a request for the <code>SetTerminationTime</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param SetTerminationTime
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_SetTerminationTime_register_request(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    WidgetPortType_SetTerminationTime_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup WidgetPortType_SetTerminationTime_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>SetTerminationTime</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param SetTerminationTimeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* WidgetPortType_SetTerminationTime_response_callback_func_t)(
    WidgetService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrl_SetTerminationTimeResponseType * SetTerminationTimeResponse,
    WidgetPortType_SetTerminationTime_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup WidgetPortType_SetTerminationTime_operation
 * Begin parsing the request for the <code>SetTerminationTime</code> operation begun
 * by an earlier call to
 * WidgetPortType_SetTerminationTime_register_request() or
 * WidgetPortType_SetTerminationTime_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_SetTerminationTime_register_response(
    WidgetService_client_handle_t handle,
    WidgetPortType_SetTerminationTime_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup WidgetPortType_SetTerminationTime_operation
 *
 * Begin processing a request for the SetTerminationTime operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param SetTerminationTime
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_SetTerminationTime_epr_register(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    WidgetPortType_SetTerminationTime_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup WidgetPortType_SetTerminationTime_operation
 *
 * Begin processing a request for the SetTerminationTime operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param SetTerminationTime
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_SetTerminationTime_register(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    WidgetPortType_SetTerminationTime_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup WidgetPortType_SetTerminationTime_operation
 *
 * Request that an the SetTerminationTime operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a SetTerminationTimeResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param SetTerminationTime
 *     Input parameter to the operation.

 * @param SetTerminationTimeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_SetTerminationTime_epr(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    wsrl_SetTerminationTimeResponseType * * SetTerminationTimeResponse,
    WidgetPortType_SetTerminationTime_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup WidgetPortType_SetTerminationTime_operation
 *
 * Request that an the SetTerminationTime operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a SetTerminationTimeResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param SetTerminationTime
 *     Input parameter to the operation.

 * @param SetTerminationTimeResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_SetTerminationTime(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrl_SetTerminationTimeType * SetTerminationTime,
    wsrl_SetTerminationTimeResponseType * * SetTerminationTimeResponse,
    WidgetPortType_SetTerminationTime_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the Destroy
 * operation
 */

/**
 * @defgroup WidgetPortType_Destroy_operation Destroy Operation
 * @ingroup WidgetService_client
 *
 * The functions and types in this group are used by clients which will
 * be making Destroy requests of the WidgetService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * WidgetPortType_Destroy() and WidgetPortType_Destroy_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, WidgetPortType_Destroy_register() and
 * WidgetPortType_Destroy_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup WidgetPortType_Destroy_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>Destroy</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* WidgetPortType_Destroy_request_callback_func_t)(
    WidgetService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup WidgetPortType_Destroy_operation
 * Begin sending a request for the <code>Destroy</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Destroy
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_Destroy_epr_register_request(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_DestroyType * Destroy,
    WidgetPortType_Destroy_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup WidgetPortType_Destroy_operation
 * Begin sending a request for the <code>Destroy</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Destroy
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_Destroy_register_request(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrl_DestroyType * Destroy,
    WidgetPortType_Destroy_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup WidgetPortType_Destroy_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>Destroy</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param DestroyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* WidgetPortType_Destroy_response_callback_func_t)(
    WidgetService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrl_DestroyResponseType * DestroyResponse,
    WidgetPortType_Destroy_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup WidgetPortType_Destroy_operation
 * Begin parsing the request for the <code>Destroy</code> operation begun
 * by an earlier call to
 * WidgetPortType_Destroy_register_request() or
 * WidgetPortType_Destroy_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_Destroy_register_response(
    WidgetService_client_handle_t handle,
    WidgetPortType_Destroy_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup WidgetPortType_Destroy_operation
 *
 * Begin processing a request for the Destroy operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Destroy
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_Destroy_epr_register(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_DestroyType * Destroy,
    WidgetPortType_Destroy_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup WidgetPortType_Destroy_operation
 *
 * Begin processing a request for the Destroy operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Destroy
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_Destroy_register(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrl_DestroyType * Destroy,
    WidgetPortType_Destroy_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup WidgetPortType_Destroy_operation
 *
 * Request that an the Destroy operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a DestroyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param Destroy
 *     Input parameter to the operation.

 * @param DestroyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_Destroy_epr(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrl_DestroyType * Destroy,
    wsrl_DestroyResponseType * * DestroyResponse,
    WidgetPortType_Destroy_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup WidgetPortType_Destroy_operation
 *
 * Request that an the Destroy operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a DestroyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param Destroy
 *     Input parameter to the operation.

 * @param DestroyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_Destroy(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrl_DestroyType * Destroy,
    wsrl_DestroyResponseType * * DestroyResponse,
    WidgetPortType_Destroy_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the QueryResourceProperties
 * operation
 */

/**
 * @defgroup WidgetPortType_QueryResourceProperties_operation QueryResourceProperties Operation
 * @ingroup WidgetService_client
 *
 * The functions and types in this group are used by clients which will
 * be making QueryResourceProperties requests of the WidgetService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * WidgetPortType_QueryResourceProperties() and WidgetPortType_QueryResourceProperties_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, WidgetPortType_QueryResourceProperties_register() and
 * WidgetPortType_QueryResourceProperties_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup WidgetPortType_QueryResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>QueryResourceProperties</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* WidgetPortType_QueryResourceProperties_request_callback_func_t)(
    WidgetService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup WidgetPortType_QueryResourceProperties_operation
 * Begin sending a request for the <code>QueryResourceProperties</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_QueryResourceProperties_epr_register_request(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    WidgetPortType_QueryResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup WidgetPortType_QueryResourceProperties_operation
 * Begin sending a request for the <code>QueryResourceProperties</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_QueryResourceProperties_register_request(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    WidgetPortType_QueryResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup WidgetPortType_QueryResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>QueryResourceProperties</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param QueryResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* WidgetPortType_QueryResourceProperties_response_callback_func_t)(
    WidgetService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_QueryResourcePropertiesResponseType * QueryResourcePropertiesResponse,
    WidgetPortType_QueryResourceProperties_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup WidgetPortType_QueryResourceProperties_operation
 * Begin parsing the request for the <code>QueryResourceProperties</code> operation begun
 * by an earlier call to
 * WidgetPortType_QueryResourceProperties_register_request() or
 * WidgetPortType_QueryResourceProperties_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_QueryResourceProperties_register_response(
    WidgetService_client_handle_t handle,
    WidgetPortType_QueryResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup WidgetPortType_QueryResourceProperties_operation
 *
 * Begin processing a request for the QueryResourceProperties operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_QueryResourceProperties_epr_register(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    WidgetPortType_QueryResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup WidgetPortType_QueryResourceProperties_operation
 *
 * Begin processing a request for the QueryResourceProperties operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param QueryResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_QueryResourceProperties_register(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    WidgetPortType_QueryResourceProperties_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup WidgetPortType_QueryResourceProperties_operation
 *
 * Request that an the QueryResourceProperties operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a QueryResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param QueryResourceProperties
 *     Input parameter to the operation.

 * @param QueryResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_QueryResourceProperties_epr(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    wsrp_QueryResourcePropertiesResponseType * * QueryResourcePropertiesResponse,
    WidgetPortType_QueryResourceProperties_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup WidgetPortType_QueryResourceProperties_operation
 *
 * Request that an the QueryResourceProperties operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a QueryResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param QueryResourceProperties
 *     Input parameter to the operation.

 * @param QueryResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_QueryResourceProperties(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    wsrp_QueryResourcePropertiesResponseType * * QueryResourcePropertiesResponse,
    WidgetPortType_QueryResourceProperties_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the SetResourceProperties
 * operation
 */

/**
 * @defgroup WidgetPortType_SetResourceProperties_operation SetResourceProperties Operation
 * @ingroup WidgetService_client
 *
 * The functions and types in this group are used by clients which will
 * be making SetResourceProperties requests of the WidgetService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * WidgetPortType_SetResourceProperties() and WidgetPortType_SetResourceProperties_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, WidgetPortType_SetResourceProperties_register() and
 * WidgetPortType_SetResourceProperties_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup WidgetPortType_SetResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>SetResourceProperties</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* WidgetPortType_SetResourceProperties_request_callback_func_t)(
    WidgetService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup WidgetPortType_SetResourceProperties_operation
 * Begin sending a request for the <code>SetResourceProperties</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param SetResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_SetResourceProperties_epr_register_request(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_SetResourcePropertiesType * SetResourceProperties,
    WidgetPortType_SetResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup WidgetPortType_SetResourceProperties_operation
 * Begin sending a request for the <code>SetResourceProperties</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param SetResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_SetResourceProperties_register_request(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrp_SetResourcePropertiesType * SetResourceProperties,
    WidgetPortType_SetResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup WidgetPortType_SetResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>SetResourceProperties</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param SetResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* WidgetPortType_SetResourceProperties_response_callback_func_t)(
    WidgetService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_SetResourcePropertiesResponseType * SetResourcePropertiesResponse,
    WidgetPortType_SetResourceProperties_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup WidgetPortType_SetResourceProperties_operation
 * Begin parsing the request for the <code>SetResourceProperties</code> operation begun
 * by an earlier call to
 * WidgetPortType_SetResourceProperties_register_request() or
 * WidgetPortType_SetResourceProperties_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_SetResourceProperties_register_response(
    WidgetService_client_handle_t handle,
    WidgetPortType_SetResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup WidgetPortType_SetResourceProperties_operation
 *
 * Begin processing a request for the SetResourceProperties operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param SetResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_SetResourceProperties_epr_register(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_SetResourcePropertiesType * SetResourceProperties,
    WidgetPortType_SetResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup WidgetPortType_SetResourceProperties_operation
 *
 * Begin processing a request for the SetResourceProperties operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param SetResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_SetResourceProperties_register(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrp_SetResourcePropertiesType * SetResourceProperties,
    WidgetPortType_SetResourceProperties_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup WidgetPortType_SetResourceProperties_operation
 *
 * Request that an the SetResourceProperties operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a SetResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param SetResourceProperties
 *     Input parameter to the operation.

 * @param SetResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_SetResourceProperties_epr(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_SetResourcePropertiesType * SetResourceProperties,
    wsrp_SetResourcePropertiesResponseType * * SetResourcePropertiesResponse,
    WidgetPortType_SetResourceProperties_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup WidgetPortType_SetResourceProperties_operation
 *
 * Request that an the SetResourceProperties operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a SetResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param SetResourceProperties
 *     Input parameter to the operation.

 * @param SetResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_SetResourceProperties(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrp_SetResourcePropertiesType * SetResourceProperties,
    wsrp_SetResourcePropertiesResponseType * * SetResourcePropertiesResponse,
    WidgetPortType_SetResourceProperties_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the GetMultipleResourceProperties
 * operation
 */

/**
 * @defgroup WidgetPortType_GetMultipleResourceProperties_operation GetMultipleResourceProperties Operation
 * @ingroup WidgetService_client
 *
 * The functions and types in this group are used by clients which will
 * be making GetMultipleResourceProperties requests of the WidgetService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * WidgetPortType_GetMultipleResourceProperties() and WidgetPortType_GetMultipleResourceProperties_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, WidgetPortType_GetMultipleResourceProperties_register() and
 * WidgetPortType_GetMultipleResourceProperties_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup WidgetPortType_GetMultipleResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>GetMultipleResourceProperties</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* WidgetPortType_GetMultipleResourceProperties_request_callback_func_t)(
    WidgetService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup WidgetPortType_GetMultipleResourceProperties_operation
 * Begin sending a request for the <code>GetMultipleResourceProperties</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_GetMultipleResourceProperties_epr_register_request(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    WidgetPortType_GetMultipleResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup WidgetPortType_GetMultipleResourceProperties_operation
 * Begin sending a request for the <code>GetMultipleResourceProperties</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_GetMultipleResourceProperties_register_request(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    WidgetPortType_GetMultipleResourceProperties_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup WidgetPortType_GetMultipleResourceProperties_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>GetMultipleResourceProperties</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param GetMultipleResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* WidgetPortType_GetMultipleResourceProperties_response_callback_func_t)(
    WidgetService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_GetMultipleResourcePropertiesResponseType * GetMultipleResourcePropertiesResponse,
    WidgetPortType_GetMultipleResourceProperties_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup WidgetPortType_GetMultipleResourceProperties_operation
 * Begin parsing the request for the <code>GetMultipleResourceProperties</code> operation begun
 * by an earlier call to
 * WidgetPortType_GetMultipleResourceProperties_register_request() or
 * WidgetPortType_GetMultipleResourceProperties_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_GetMultipleResourceProperties_register_response(
    WidgetService_client_handle_t handle,
    WidgetPortType_GetMultipleResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup WidgetPortType_GetMultipleResourceProperties_operation
 *
 * Begin processing a request for the GetMultipleResourceProperties operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_GetMultipleResourceProperties_epr_register(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    WidgetPortType_GetMultipleResourceProperties_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup WidgetPortType_GetMultipleResourceProperties_operation
 *
 * Begin processing a request for the GetMultipleResourceProperties operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_GetMultipleResourceProperties_register(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    WidgetPortType_GetMultipleResourceProperties_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup WidgetPortType_GetMultipleResourceProperties_operation
 *
 * Request that an the GetMultipleResourceProperties operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetMultipleResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.

 * @param GetMultipleResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_GetMultipleResourceProperties_epr(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    wsrp_GetMultipleResourcePropertiesResponseType * * GetMultipleResourcePropertiesResponse,
    WidgetPortType_GetMultipleResourceProperties_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup WidgetPortType_GetMultipleResourceProperties_operation
 *
 * Request that an the GetMultipleResourceProperties operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetMultipleResourcePropertiesResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetMultipleResourceProperties
 *     Input parameter to the operation.

 * @param GetMultipleResourcePropertiesResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_GetMultipleResourceProperties(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    wsrp_GetMultipleResourcePropertiesResponseType * * GetMultipleResourcePropertiesResponse,
    WidgetPortType_GetMultipleResourceProperties_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the GetResourceProperty
 * operation
 */

/**
 * @defgroup WidgetPortType_GetResourceProperty_operation GetResourceProperty Operation
 * @ingroup WidgetService_client
 *
 * The functions and types in this group are used by clients which will
 * be making GetResourceProperty requests of the WidgetService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * WidgetPortType_GetResourceProperty() and WidgetPortType_GetResourceProperty_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, WidgetPortType_GetResourceProperty_register() and
 * WidgetPortType_GetResourceProperty_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup WidgetPortType_GetResourceProperty_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>GetResourceProperty</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* WidgetPortType_GetResourceProperty_request_callback_func_t)(
    WidgetService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup WidgetPortType_GetResourceProperty_operation
 * Begin sending a request for the <code>GetResourceProperty</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_GetResourceProperty_epr_register_request(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    WidgetPortType_GetResourceProperty_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup WidgetPortType_GetResourceProperty_operation
 * Begin sending a request for the <code>GetResourceProperty</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_GetResourceProperty_register_request(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    WidgetPortType_GetResourceProperty_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup WidgetPortType_GetResourceProperty_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>GetResourceProperty</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* WidgetPortType_GetResourceProperty_response_callback_func_t)(
    WidgetService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const wsrp_GetResourcePropertyResponseType * GetResourcePropertyResponse,
    WidgetPortType_GetResourceProperty_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup WidgetPortType_GetResourceProperty_operation
 * Begin parsing the request for the <code>GetResourceProperty</code> operation begun
 * by an earlier call to
 * WidgetPortType_GetResourceProperty_register_request() or
 * WidgetPortType_GetResourceProperty_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_GetResourceProperty_register_response(
    WidgetService_client_handle_t handle,
    WidgetPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup WidgetPortType_GetResourceProperty_operation
 *
 * Begin processing a request for the GetResourceProperty operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_GetResourceProperty_epr_register(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    WidgetPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup WidgetPortType_GetResourceProperty_operation
 *
 * Begin processing a request for the GetResourceProperty operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_GetResourceProperty_register(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    WidgetPortType_GetResourceProperty_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup WidgetPortType_GetResourceProperty_operation
 *
 * Request that an the GetResourceProperty operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetResourcePropertyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param GetResourceProperty
 *     Input parameter to the operation.

 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_GetResourceProperty_epr(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const xsd_QName * GetResourceProperty,
    wsrp_GetResourcePropertyResponseType * * GetResourcePropertyResponse,
    WidgetPortType_GetResourceProperty_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup WidgetPortType_GetResourceProperty_operation
 *
 * Request that an the GetResourceProperty operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a GetResourcePropertyResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param GetResourceProperty
 *     Input parameter to the operation.

 * @param GetResourcePropertyResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_GetResourceProperty(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const xsd_QName * GetResourceProperty,
    wsrp_GetResourcePropertyResponseType * * GetResourcePropertyResponse,
    WidgetPortType_GetResourceProperty_fault_t * fault_type,
    xsd_any * * fault);



/* Type and function declarations for the createWidget
 * operation
 */

/**
 * @defgroup WidgetPortType_createWidget_operation createWidget Operation
 * @ingroup WidgetService_client
 *
 * The functions and types in this group are used by clients which will
 * be making createWidget requests of the WidgetService service.
 *
 * For clients which want blocking SOAP calls, the functions
 * WidgetPortType_createWidget() and WidgetPortType_createWidget_epr() will be most appropriate. For
 * clients which want nonblocking SOAP calls, WidgetPortType_createWidget_register() and
 * WidgetPortType_createWidget_epr_register() will be most appropriate.
 *
 * The other functions in this section are used by applications which require
 * more control over the operation invocation by having separate invocations
 * and callbacks for the request and response handling of the operation.
 */

/**
 * Request callback function
 * @ingroup WidgetPortType_createWidget_operation
 * Use a function of this type when calling one of the nonblocking request
 * functions for the <code>createWidget</code> operation.
 *

 * When the request has been sent to the service, this callback function
 * will be called. If the result is <code>GLOBUS_SUCCESS</code>, then the
 * application must then call one of the response functions with the same
 * handle to receive the response to this operation.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 */
typedef void (* WidgetPortType_createWidget_request_callback_func_t)(
    WidgetService_client_handle_t handle,
    void * user_args,
    globus_result_t result);
 
/**
 * Nonblocking operation request with EPR
 * @ingroup WidgetPortType_createWidget_operation
 * Begin sending a request for the <code>createWidget</code> operation on a
 * resource handled by the service named by the @a epr. When the operation
 * request has been sent, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param createWidget
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_createWidget_epr_register_request(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const createWidgetType * createWidget,
    WidgetPortType_createWidget_request_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation request
 * @ingroup WidgetPortType_createWidget_operation
 * Begin sending a request for the <code>createWidget</code> operation to
 * the service at @a endpoint. When the operation
 * request has been sent, the @a callback function will be invoked.
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param createWidget
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the request has been
 *     sent
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_createWidget_register_request(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const createWidgetType * createWidget,
    WidgetPortType_createWidget_request_callback_func_t callback,
    void * user_args);

/**
 * Response callback function
 * @ingroup WidgetPortType_createWidget_operation
 * Use a function of this type when calling one of the nonblocking operation
 * or response functions for the <code>createWidget</code> operation.
 *
 * When the response has been received from the service, this callback function
 * will be called. 
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink used for
 *     the operation invocation.
 * @param user_args
 *     Application specific pointer, passed to the operation's register
 *     function.
 * @param result
 *     The result of operation request.
 * @param createWidgetResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.
 */
typedef void (* WidgetPortType_createWidget_response_callback_func_t)(
    WidgetService_client_handle_t handle,
    void *                              user_args,
    globus_result_t                     result,
    const createWidgetResponseType * createWidgetResponse,
    WidgetPortType_createWidget_fault_t fault_type,
    const xsd_any *                     fault);

/**
 * Nonblocking operation response handling
 * @ingroup WidgetPortType_createWidget_operation
 * Begin parsing the request for the <code>createWidget</code> operation begun
 * by an earlier call to
 * WidgetPortType_createWidget_register_request() or
 * WidgetPortType_createWidget_epr_register_request().  Once the response has been parsed.
 * the @a callback function will be called to pass the result of the operation
 * to the application.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param callback
 *     Callback function which will be called once the response has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_createWidget_register_response(
    WidgetService_client_handle_t handle,
    WidgetPortType_createWidget_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation with EPR
 * @ingroup WidgetPortType_createWidget_operation
 *
 * Begin processing a request for the createWidget operation. The operation will
 * sent to the service named by the @a epr and after the response is received,
 * the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param createWidget
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_createWidget_epr_register(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const createWidgetType * createWidget,
    WidgetPortType_createWidget_response_callback_func_t callback,
    void * user_args);

/**
 * Nonblocking operation invocation
 * @ingroup WidgetPortType_createWidget_operation
 *
 * Begin processing a request for the createWidget operation. The operation will
 * sent to the service located at @a endpoint and after the response is
 * received, the @a callback function will be invoked.
 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param createWidget
 *     Input parameter to the operation.
 * @param callback
 *     Callback function which will be called once the operation has been
 *     processed.
 * @param user_args
 *     Application-specific pointer which will be passed to the callback.
 */
globus_result_t
WidgetPortType_createWidget_register(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const createWidgetType * createWidget,
    WidgetPortType_createWidget_response_callback_func_t callback,
    void * user_args);


/**
 * Blocking operation invocation with EPR
 * @ingroup WidgetPortType_createWidget_operation
 *
 * Request that an the createWidget operation be invoked by the service and
 * resource named by the @a epr parameter.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a createWidgetResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param epr
 *     Endpoint Reference of the service and resource which will process
 *     the operation.
 * @param createWidget
 *     Input parameter to the operation.

 * @param createWidgetResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_createWidget_epr(
    WidgetService_client_handle_t handle,
    const wsa_EndpointReferenceType * epr,
    const createWidgetType * createWidget,
    createWidgetResponseType * * createWidgetResponse,
    WidgetPortType_createWidget_fault_t * fault_type,
    xsd_any * * fault);

/**
 * Blocking operation invocation
 * @ingroup WidgetPortType_createWidget_operation
 *
 * Request that an the createWidget operation be invoked by the service at
 * @a endpoint.

 * If the result is <code>GLOBUS_SUCCESS</code>, then the
 * @a createWidgetResponse parameter will be set to the result of the operation.
 * Otherwise, if the @a fault and @a fault_type parameters are non-NULL,
 * they indicate the SOAP fault type. If they are NULL, then some non-SOAP
 * error occurred, and the result's error type should be checked.

 *
 * @param handle
 *     The @link #WidgetService_client_handle_t client handle @endlink which
 *     contains the state related to processing this operation.
 * @param endpoint
 *     URI of the service endpoint to send the request to.
 * @param createWidget
 *     Input parameter to the operation.

 * @param createWidgetResponse
 *     The output of the operation, if the operation succeeded.
 * @param fault_type
 *     The type of fault sent as a result of the operation, if the operation
 *     failed. If the operation succeeded, this will be NULL.
 * @param fault
 *     The fault element which was received, if the operation failed.
 *     If the operation succeeded, this will be NULL.

 */
globus_result_t
WidgetPortType_createWidget(
    WidgetService_client_handle_t handle,
    const char * endpoint,
    const createWidgetType * createWidget,
    createWidgetResponseType * * createWidgetResponse,
    WidgetPortType_createWidget_fault_t * fault_type,
    xsd_any * * fault);



/**
 * Initialize a client handle
 * @ingroup WidgetService_client_handle
 * Initialize new client handle state for use with operation-related functions.
 *
 * @param handle
 *     Pointer to the handle to initialize.
 * @param attrs
 *    Default attributes to use with this handle. This parameter may be NULL.
 *    Certain atttributes may cause different handlers to be pushed onto the
 *    default handler chain for this client.
 * @param handlers
 *    Handle chain to use with this handle. This parameter may be NULL.
 *    Typically the default handler chain used by this function is sufficient.
 */
globus_result_t
WidgetService_client_init(
    WidgetService_client_handle_t *  handle,
    globus_soap_message_attr_t attrs,
    globus_handler_chain_t handlers);

/**
 * Destroy a client handle
 * @ingroup WidgetService_client_handle
 *
 * Destroys the state associated with this client handle.
 *
 * @param handle
 *     Handle to destroy.
 */
void
WidgetService_client_destroy(
    WidgetService_client_handle_t handle);

/**
 * Cancel the current operation associated with this handle.
 * @ingroup WidgetService_client_handle
 * 
 * @param handle
 *     Handle which has the operation to cancel.
 */
globus_result_t
WidgetService_client_operation_cancel(
    WidgetService_client_handle_t handle);

/**
 * Get handle's type registry
 * @ingroup WidgetService_client_handle
 *
 * The type registry maps XML element names to type information structures.
 * Applications may wish to get the registry from a handle to set extra
 * type mappings (for example, to set a mapping for an element which is
 * to be received as part of an extensibility element).
 *
 * @param handle
 *     The handle to query.
 * @param registry
 *     A pointer to a registry handle which will be set to the handle's
 *     registry.
 */
globus_result_t
WidgetService_client_get_registry(
    WidgetService_client_handle_t handle,
    globus_xsd_type_registry_t * registry);

/**
 * Get handle's handler chain
 * @ingroup WidgetService_client_handle
 *
 * The handler chain contains information about which handlers (typically
 * SOAP header processors) will be invoked when a request is sent or a
 * response is received. Applications which want to add custom handlers at
 * run time may wish to push additional handlers onto this chain.
 *
 * @param handle
 *     The handle to query.
 * @param handlers
 *     A pointer to a handler chain which will be set to the handle's
 *     chain.
 */
globus_result_t
WidgetService_client_get_handler_chain(
    WidgetService_client_handle_t handle,
    globus_handler_chain_t * handlers);

/**
 * Set a SOAP attribute on a handle
 * @ingroup WidgetService_client_handle
 *
 * Set a SOAP attribute on a handle. This can be used to change how
 * the SOAP engine will process operations sent via this handle.
 *
 * @param handle
 *     The handle to modify.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * @param copy
 *     A function to copy the value. This is required if @a value will go
 *     out of scope.
 * @param destroy
 *     A function to destroy a copy of the value. Required if @a copy is set.
 * @param value
 *     The new value of the attribute.
 */
globus_result_t
WidgetService_client_attr_set(
    WidgetService_client_handle_t handle,
    const char * prop_name,
    globus_soap_message_attr_copy_func_t copy,
    globus_soap_message_attr_destroy_func_t destroy,
    void * value);

/**
 * Remove a SOAP attribute from a handle
 * @ingroup WidgetService_client_handle
 *
 * Remove a SOAP attribute on a handle. This can be used to change how
 * the SOAP engine will process operations sent via this handle.
 *
 * @param handle
 *     The handle to modify.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * 
 * @return
 *     This function returns the current value of the attribute.
 */
void *
WidgetService_client_attr_remove(
    WidgetService_client_handle_t handle,
    const char * prop_name);

/**
 * Get a SOAP attribute from a handle
 * @ingroup WidgetService_client_handle
 *
 * Get the current value of a SOAP attribute set on a handle. 
 *
 * @param handle
 *     The handle to query.
 * @param prop_name
 *     The attribute name. This should be one of the
 *     <code>GLOBUS_SOAP_MESSAGE_*_KEY</code> values.
 * 
 * @return
 *     This function returns the current value of the attribute.
 */
void *
WidgetService_client_attr_get(
    WidgetService_client_handle_t handle,
    const char * prop_name);

EXTERN_C_END

#endif
