/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _CREATECOUNTERRESPONSETYPE_H_
#define _CREATECOUNTERRESPONSETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The createCounterResponseType complex type, which represents the
 * {http://counter.com}complexType 2 element.
 * @ingroup createCounterResponseType
 */
typedef struct createCounterResponseType_s createCounterResponseType;
/**
 * The createCounterResponseType_o complex type, which represents an optional instance
 * of a
 * {http://counter.com}complexType 2 element.
 * @ingroup createCounterResponseType
 */
typedef createCounterResponseType * createCounterResponseType_o;

/**
 * Namespace of the createCounterResponseType complex type
 * @ingroup createCounterResponseType
 */
#define CREATECOUNTERRESPONSETYPE_NS "http://counter.com"
/**
 * Local part of the QName of the createCounterResponseType complex type
 * @ingroup createCounterResponseType
 */
#define CREATECOUNTERRESPONSETYPE_LOCAL "createCounterResponseType"

/**
 * QName of the createCounterResponseType complex type
 * @ingroup createCounterResponseType
 */
extern xsd_QName createCounterResponseType_qname;
/**
 * Type information for serializing and deserializing createCounterResponseType elements
 * @ingroup createCounterResponseType
 */
extern struct globus_xsd_type_info_s createCounterResponseType_info;
/**
 * Type information for serializing and deserializing arrays of createCounterResponseType
 * elements
 * @ingroup createCounterResponseType
 */
extern struct globus_xsd_type_info_s createCounterResponseType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * createCounterResponseType without surrounding elements
 * @ingroup createCounterResponseType
 */
extern struct globus_xsd_type_info_s createCounterResponseType_contents_info;


#include "wsa_EndpointReferenceType.h"
#include "createCounterResponseType_array.h"

/**
 * @defgroup createCounterResponseType Complex type: createCounterResponseType
 * @ingroup types
 */

/**
 * C structure for the createCounterResponseType complex type
 * @ingroup createCounterResponseType
 */
struct createCounterResponseType_s
{
    /** wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType EndpointReference;

};

/**
 * Initialize a createCounterResponseType
 * @ingroup createCounterResponseType
 *
 * Allocates a new createCounterResponseType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * createCounterResponseType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
createCounterResponseType_init(
    createCounterResponseType ** inst);

/**
 * Destroy a createCounterResponseType
 * @ingroup createCounterResponseType
 *
 * Frees a createCounterResponseType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
createCounterResponseType_destroy(
    createCounterResponseType * inst);

/**
 * Copy a createCounterResponseType
 * @ingroup createCounterResponseType
 *
 * Perform a deep copy of a createCounterResponseType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The createCounterResponseType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source createCounterResponseType to be copied.
 */
globus_result_t
createCounterResponseType_copy(
    createCounterResponseType ** dest,
    const createCounterResponseType * src);

/**
 * Initialize the contents of a createCounterResponseType
 * @ingroup createCounterResponseType
 *
 * Initialize the contents of a createCounterResponseType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * createCounterResponseType_init(). The contents may be freed
 * by calling createCounterResponseType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized createCounterResponseType.
 */
globus_result_t
createCounterResponseType_init_contents(
    createCounterResponseType * instance);

/**
 * Destroy the contents of a createCounterResponseType
 * @ingroup createCounterResponseType
 *
 * Destroy the subelements and attributes of the given createCounterResponseType. 
 *
 * @param inst
 *     Pointer to a createCounterResponseType instance to destroy.
 */
void
createCounterResponseType_destroy_contents(
    createCounterResponseType * inst);

/**
 * Copy the contents of a createCounterResponseType
 * @ingroup createCounterResponseType
 *
 * Perform a deep copy of the contents of a createCounterResponseType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source createCounterResponseType to be copied.
 */
globus_result_t
createCounterResponseType_copy_contents(
    createCounterResponseType * dest,
    const createCounterResponseType * src);

/**
 * Serialize a createCounterResponseType
 * @ingroup createCounterResponseType_array
 * Serialize a createCounterResponseType structure.
 *
 * @param element_name
 *     The name of the element which will contain the createCounterResponseType.
 * @param val
 *     The createCounterResponseType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
createCounterResponseType_serialize(
    xsd_QName *                         element_name,
    createCounterResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a createCounterResponseType
 * @ingroup createCounterResponseType_array
 * Serialize a createCounterResponseType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The createCounterResponseType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
createCounterResponseType_serialize_contents(
    xsd_QName *                         element_name,
    createCounterResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a createCounterResponseType
 * @ingroup createCounterResponseType
 * Deserialize an element containing a createCounterResponseType element.
 *
 * @param element_name
 *     The name of the element which should enclose the createCounterResponseType.
 * @param val
 *     Pointer to the createCounterResponseType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
createCounterResponseType_deserialize(
    xsd_QName *                         element_name,
    createCounterResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a createCounterResponseType
 * @ingroup createCounterResponseType
 * Deserialize a createCounterResponseType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the createCounterResponseType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
createCounterResponseType_deserialize_contents(
    xsd_QName *                         element_name,
    createCounterResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional createCounterResponseType
 * @ingroup createCounterResponseType
 * Deserialize the next element if it contains a createCounterResponseType.
 *
 * @param element_name
 *     The name of the element which should enclose the createCounterResponseType.
 * @param instance
 *     Pointer to the <code>createCounterResponseType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
createCounterResponseType_deserialize_pointer(
    xsd_QName *                         element_name,
    createCounterResponseType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
createCounterResponseType_init_wrapper(
    void **                             object);
    
void
createCounterResponseType_destroy_wrapper(
    void *                              object);
    
globus_result_t
createCounterResponseType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
createCounterResponseType_init_contents_wrapper(
    void *                              object);
    
void
createCounterResponseType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
createCounterResponseType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
createCounterResponseType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
createCounterResponseType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
createCounterResponseType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
createCounterResponseType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
