/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _CREATECOUNTERTYPE_H_
#define _CREATECOUNTERTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The createCounterType complex type, which represents the
 * {http://counter.com}complexType 1 element.
 * @ingroup createCounterType
 */
typedef struct createCounterType_s createCounterType;
/**
 * The createCounterType_o complex type, which represents an optional instance
 * of a
 * {http://counter.com}complexType 1 element.
 * @ingroup createCounterType
 */
typedef createCounterType * createCounterType_o;

/**
 * Namespace of the createCounterType complex type
 * @ingroup createCounterType
 */
#define CREATECOUNTERTYPE_NS "http://counter.com"
/**
 * Local part of the QName of the createCounterType complex type
 * @ingroup createCounterType
 */
#define CREATECOUNTERTYPE_LOCAL "createCounterType"

/**
 * QName of the createCounterType complex type
 * @ingroup createCounterType
 */
extern xsd_QName createCounterType_qname;
/**
 * Type information for serializing and deserializing createCounterType elements
 * @ingroup createCounterType
 */
extern struct globus_xsd_type_info_s createCounterType_info;
/**
 * Type information for serializing and deserializing arrays of createCounterType
 * elements
 * @ingroup createCounterType
 */
extern struct globus_xsd_type_info_s createCounterType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * createCounterType without surrounding elements
 * @ingroup createCounterType
 */
extern struct globus_xsd_type_info_s createCounterType_contents_info;


#include "createCounterType_array.h"

/**
 * @defgroup createCounterType Complex type: createCounterType
 * @ingroup types
 */

/**
 * C structure for the createCounterType complex type
 * @ingroup createCounterType
 */
struct createCounterType_s
{

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
    /* WSDL defines type without containing elements or attributes, 
     * but C cannot have empty structs, so we add a dummy variable */
    void *                              DUMMY_VARIABLE;
#endif

};

/**
 * Initialize a createCounterType
 * @ingroup createCounterType
 *
 * Allocates a new createCounterType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * createCounterType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
createCounterType_init(
    createCounterType ** inst);

/**
 * Destroy a createCounterType
 * @ingroup createCounterType
 *
 * Frees a createCounterType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
createCounterType_destroy(
    createCounterType * inst);

/**
 * Copy a createCounterType
 * @ingroup createCounterType
 *
 * Perform a deep copy of a createCounterType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The createCounterType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source createCounterType to be copied.
 */
globus_result_t
createCounterType_copy(
    createCounterType ** dest,
    const createCounterType * src);

/**
 * Initialize the contents of a createCounterType
 * @ingroup createCounterType
 *
 * Initialize the contents of a createCounterType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * createCounterType_init(). The contents may be freed
 * by calling createCounterType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized createCounterType.
 */
globus_result_t
createCounterType_init_contents(
    createCounterType * instance);

/**
 * Destroy the contents of a createCounterType
 * @ingroup createCounterType
 *
 * Destroy the subelements and attributes of the given createCounterType. 
 *
 * @param inst
 *     Pointer to a createCounterType instance to destroy.
 */
void
createCounterType_destroy_contents(
    createCounterType * inst);

/**
 * Copy the contents of a createCounterType
 * @ingroup createCounterType
 *
 * Perform a deep copy of the contents of a createCounterType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source createCounterType to be copied.
 */
globus_result_t
createCounterType_copy_contents(
    createCounterType * dest,
    const createCounterType * src);

/**
 * Serialize a createCounterType
 * @ingroup createCounterType_array
 * Serialize a createCounterType structure.
 *
 * @param element_name
 *     The name of the element which will contain the createCounterType.
 * @param val
 *     The createCounterType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
createCounterType_serialize(
    xsd_QName *                         element_name,
    createCounterType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a createCounterType
 * @ingroup createCounterType_array
 * Serialize a createCounterType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The createCounterType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
createCounterType_serialize_contents(
    xsd_QName *                         element_name,
    createCounterType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a createCounterType
 * @ingroup createCounterType
 * Deserialize an element containing a createCounterType element.
 *
 * @param element_name
 *     The name of the element which should enclose the createCounterType.
 * @param val
 *     Pointer to the createCounterType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
createCounterType_deserialize(
    xsd_QName *                         element_name,
    createCounterType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a createCounterType
 * @ingroup createCounterType
 * Deserialize a createCounterType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the createCounterType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
createCounterType_deserialize_contents(
    xsd_QName *                         element_name,
    createCounterType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional createCounterType
 * @ingroup createCounterType
 * Deserialize the next element if it contains a createCounterType.
 *
 * @param element_name
 *     The name of the element which should enclose the createCounterType.
 * @param instance
 *     Pointer to the <code>createCounterType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
createCounterType_deserialize_pointer(
    xsd_QName *                         element_name,
    createCounterType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
createCounterType_init_wrapper(
    void **                             object);
    
void
createCounterType_destroy_wrapper(
    void *                              object);
    
globus_result_t
createCounterType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
createCounterType_init_contents_wrapper(
    void *                              object);
    
void
createCounterType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
createCounterType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
createCounterType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
createCounterType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
createCounterType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
createCounterType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
