/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _CREATEWIDGETRESPONSETYPE_H_
#define _CREATEWIDGETRESPONSETYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The createWidgetResponseType complex type, which represents the
 * {http://widgets.com}complexType 2 element.
 * @ingroup createWidgetResponseType
 */
typedef struct createWidgetResponseType_s createWidgetResponseType;
/**
 * The createWidgetResponseType_o complex type, which represents an optional instance
 * of a
 * {http://widgets.com}complexType 2 element.
 * @ingroup createWidgetResponseType
 */
typedef createWidgetResponseType * createWidgetResponseType_o;

/**
 * Namespace of the createWidgetResponseType complex type
 * @ingroup createWidgetResponseType
 */
#define CREATEWIDGETRESPONSETYPE_NS "http://widgets.com"
/**
 * Local part of the QName of the createWidgetResponseType complex type
 * @ingroup createWidgetResponseType
 */
#define CREATEWIDGETRESPONSETYPE_LOCAL "createWidgetResponseType"

/**
 * QName of the createWidgetResponseType complex type
 * @ingroup createWidgetResponseType
 */
extern xsd_QName createWidgetResponseType_qname;
/**
 * Type information for serializing and deserializing createWidgetResponseType elements
 * @ingroup createWidgetResponseType
 */
extern struct globus_xsd_type_info_s createWidgetResponseType_info;
/**
 * Type information for serializing and deserializing arrays of createWidgetResponseType
 * elements
 * @ingroup createWidgetResponseType
 */
extern struct globus_xsd_type_info_s createWidgetResponseType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * createWidgetResponseType without surrounding elements
 * @ingroup createWidgetResponseType
 */
extern struct globus_xsd_type_info_s createWidgetResponseType_contents_info;


#include "wsa_EndpointReferenceType.h"
#include "createWidgetResponseType_array.h"

/**
 * @defgroup createWidgetResponseType Complex type: createWidgetResponseType
 * @ingroup types
 */

/**
 * C structure for the createWidgetResponseType complex type
 * @ingroup createWidgetResponseType
 */
struct createWidgetResponseType_s
{
    /** wsa_EndpointReferenceType subelement */
    wsa_EndpointReferenceType EndpointReference;

};

/**
 * Initialize a createWidgetResponseType
 * @ingroup createWidgetResponseType
 *
 * Allocates a new createWidgetResponseType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * createWidgetResponseType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
createWidgetResponseType_init(
    createWidgetResponseType ** inst);

/**
 * Destroy a createWidgetResponseType
 * @ingroup createWidgetResponseType
 *
 * Frees a createWidgetResponseType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
createWidgetResponseType_destroy(
    createWidgetResponseType * inst);

/**
 * Copy a createWidgetResponseType
 * @ingroup createWidgetResponseType
 *
 * Perform a deep copy of a createWidgetResponseType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The createWidgetResponseType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source createWidgetResponseType to be copied.
 */
globus_result_t
createWidgetResponseType_copy(
    createWidgetResponseType ** dest,
    const createWidgetResponseType * src);

/**
 * Initialize the contents of a createWidgetResponseType
 * @ingroup createWidgetResponseType
 *
 * Initialize the contents of a createWidgetResponseType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * createWidgetResponseType_init(). The contents may be freed
 * by calling createWidgetResponseType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized createWidgetResponseType.
 */
globus_result_t
createWidgetResponseType_init_contents(
    createWidgetResponseType * instance);

/**
 * Destroy the contents of a createWidgetResponseType
 * @ingroup createWidgetResponseType
 *
 * Destroy the subelements and attributes of the given createWidgetResponseType. 
 *
 * @param inst
 *     Pointer to a createWidgetResponseType instance to destroy.
 */
void
createWidgetResponseType_destroy_contents(
    createWidgetResponseType * inst);

/**
 * Copy the contents of a createWidgetResponseType
 * @ingroup createWidgetResponseType
 *
 * Perform a deep copy of the contents of a createWidgetResponseType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source createWidgetResponseType to be copied.
 */
globus_result_t
createWidgetResponseType_copy_contents(
    createWidgetResponseType * dest,
    const createWidgetResponseType * src);

/**
 * Serialize a createWidgetResponseType
 * @ingroup createWidgetResponseType_array
 * Serialize a createWidgetResponseType structure.
 *
 * @param element_name
 *     The name of the element which will contain the createWidgetResponseType.
 * @param val
 *     The createWidgetResponseType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
createWidgetResponseType_serialize(
    xsd_QName *                         element_name,
    createWidgetResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a createWidgetResponseType
 * @ingroup createWidgetResponseType_array
 * Serialize a createWidgetResponseType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The createWidgetResponseType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
createWidgetResponseType_serialize_contents(
    xsd_QName *                         element_name,
    createWidgetResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a createWidgetResponseType
 * @ingroup createWidgetResponseType
 * Deserialize an element containing a createWidgetResponseType element.
 *
 * @param element_name
 *     The name of the element which should enclose the createWidgetResponseType.
 * @param val
 *     Pointer to the createWidgetResponseType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
createWidgetResponseType_deserialize(
    xsd_QName *                         element_name,
    createWidgetResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a createWidgetResponseType
 * @ingroup createWidgetResponseType
 * Deserialize a createWidgetResponseType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the createWidgetResponseType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
createWidgetResponseType_deserialize_contents(
    xsd_QName *                         element_name,
    createWidgetResponseType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional createWidgetResponseType
 * @ingroup createWidgetResponseType
 * Deserialize the next element if it contains a createWidgetResponseType.
 *
 * @param element_name
 *     The name of the element which should enclose the createWidgetResponseType.
 * @param instance
 *     Pointer to the <code>createWidgetResponseType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
createWidgetResponseType_deserialize_pointer(
    xsd_QName *                         element_name,
    createWidgetResponseType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
createWidgetResponseType_init_wrapper(
    void **                             object);
    
void
createWidgetResponseType_destroy_wrapper(
    void *                              object);
    
globus_result_t
createWidgetResponseType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
createWidgetResponseType_init_contents_wrapper(
    void *                              object);
    
void
createWidgetResponseType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
createWidgetResponseType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
createWidgetResponseType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
createWidgetResponseType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
createWidgetResponseType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
createWidgetResponseType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
