/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _CREATEWIDGETTYPE_H_
#define _CREATEWIDGETTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The createWidgetType complex type, which represents the
 * {http://widgets.com}complexType 1 element.
 * @ingroup createWidgetType
 */
typedef struct createWidgetType_s createWidgetType;
/**
 * The createWidgetType_o complex type, which represents an optional instance
 * of a
 * {http://widgets.com}complexType 1 element.
 * @ingroup createWidgetType
 */
typedef createWidgetType * createWidgetType_o;

/**
 * Namespace of the createWidgetType complex type
 * @ingroup createWidgetType
 */
#define CREATEWIDGETTYPE_NS "http://widgets.com"
/**
 * Local part of the QName of the createWidgetType complex type
 * @ingroup createWidgetType
 */
#define CREATEWIDGETTYPE_LOCAL "createWidgetType"

/**
 * QName of the createWidgetType complex type
 * @ingroup createWidgetType
 */
extern xsd_QName createWidgetType_qname;
/**
 * Type information for serializing and deserializing createWidgetType elements
 * @ingroup createWidgetType
 */
extern struct globus_xsd_type_info_s createWidgetType_info;
/**
 * Type information for serializing and deserializing arrays of createWidgetType
 * elements
 * @ingroup createWidgetType
 */
extern struct globus_xsd_type_info_s createWidgetType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * createWidgetType without surrounding elements
 * @ingroup createWidgetType
 */
extern struct globus_xsd_type_info_s createWidgetType_contents_info;


#include "createWidgetType_array.h"

/**
 * @defgroup createWidgetType Complex type: createWidgetType
 * @ingroup types
 */

/**
 * C structure for the createWidgetType complex type
 * @ingroup createWidgetType
 */
struct createWidgetType_s
{

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
    /* WSDL defines type without containing elements or attributes, 
     * but C cannot have empty structs, so we add a dummy variable */
    void *                              DUMMY_VARIABLE;
#endif

};

/**
 * Initialize a createWidgetType
 * @ingroup createWidgetType
 *
 * Allocates a new createWidgetType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * createWidgetType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
createWidgetType_init(
    createWidgetType ** inst);

/**
 * Destroy a createWidgetType
 * @ingroup createWidgetType
 *
 * Frees a createWidgetType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
createWidgetType_destroy(
    createWidgetType * inst);

/**
 * Copy a createWidgetType
 * @ingroup createWidgetType
 *
 * Perform a deep copy of a createWidgetType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The createWidgetType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source createWidgetType to be copied.
 */
globus_result_t
createWidgetType_copy(
    createWidgetType ** dest,
    const createWidgetType * src);

/**
 * Initialize the contents of a createWidgetType
 * @ingroup createWidgetType
 *
 * Initialize the contents of a createWidgetType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * createWidgetType_init(). The contents may be freed
 * by calling createWidgetType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized createWidgetType.
 */
globus_result_t
createWidgetType_init_contents(
    createWidgetType * instance);

/**
 * Destroy the contents of a createWidgetType
 * @ingroup createWidgetType
 *
 * Destroy the subelements and attributes of the given createWidgetType. 
 *
 * @param inst
 *     Pointer to a createWidgetType instance to destroy.
 */
void
createWidgetType_destroy_contents(
    createWidgetType * inst);

/**
 * Copy the contents of a createWidgetType
 * @ingroup createWidgetType
 *
 * Perform a deep copy of the contents of a createWidgetType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source createWidgetType to be copied.
 */
globus_result_t
createWidgetType_copy_contents(
    createWidgetType * dest,
    const createWidgetType * src);

/**
 * Serialize a createWidgetType
 * @ingroup createWidgetType_array
 * Serialize a createWidgetType structure.
 *
 * @param element_name
 *     The name of the element which will contain the createWidgetType.
 * @param val
 *     The createWidgetType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
createWidgetType_serialize(
    xsd_QName *                         element_name,
    createWidgetType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a createWidgetType
 * @ingroup createWidgetType_array
 * Serialize a createWidgetType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The createWidgetType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
createWidgetType_serialize_contents(
    xsd_QName *                         element_name,
    createWidgetType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a createWidgetType
 * @ingroup createWidgetType
 * Deserialize an element containing a createWidgetType element.
 *
 * @param element_name
 *     The name of the element which should enclose the createWidgetType.
 * @param val
 *     Pointer to the createWidgetType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
createWidgetType_deserialize(
    xsd_QName *                         element_name,
    createWidgetType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a createWidgetType
 * @ingroup createWidgetType
 * Deserialize a createWidgetType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the createWidgetType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
createWidgetType_deserialize_contents(
    xsd_QName *                         element_name,
    createWidgetType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional createWidgetType
 * @ingroup createWidgetType
 * Deserialize the next element if it contains a createWidgetType.
 *
 * @param element_name
 *     The name of the element which should enclose the createWidgetType.
 * @param instance
 *     Pointer to the <code>createWidgetType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
createWidgetType_deserialize_pointer(
    xsd_QName *                         element_name,
    createWidgetType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
createWidgetType_init_wrapper(
    void **                             object);
    
void
createWidgetType_destroy_wrapper(
    void *                              object);
    
globus_result_t
createWidgetType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
createWidgetType_init_contents_wrapper(
    void *                              object);
    
void
createWidgetType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
createWidgetType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
createWidgetType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
createWidgetType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
createWidgetType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
createWidgetType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
