/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _RPTEST_TESTSTEPTYPE_CHOICE_H_
#define _RPTEST_TESTSTEPTYPE_CHOICE_H_

#include "globus_common.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

enum rptest_TestStepType_e
{
    rptest_TestStepType_undefined,
    rptest_TestStepType_GetResourcePropertyTest,
    rptest_TestStepType_GetMultipleResourcePropertiesTest,
    rptest_TestStepType_SetResourcePropertiesTest,
    rptest_TestStepType_QueryResourcePropertiesTest

};

/**
 * @defgroup rptest_TestStepType_choice Complex choice type: rptest_TestStepType
 * @ingroup rptest_TestStepType
 */

/**
 * Enumeration of the types of values which the rptest_TestStepType_choice
 * structure may take on.
 * @ingroup rptest_TestStepType_choice
 */
typedef enum rptest_TestStepType_e rptest_TestStepType_enum;
/**
 * Union of the values which the rptest_TestStepType_choice structure
 * contains
 * @ingroup rptest_TestStepType_choice
 */
typedef union rptest_TestStepType_u rptest_TestStepType_union;
/**
 * The rptest_TestStepType complex type, which represents the various values
 * possible by the choice used by the
 * {http://www.globus.org/namespaces/2004/10/ResourcePropertiesTest}choice 38 element.
 * @ingroup rptest_TestStepType_choice
 */
typedef struct rptest_TestStepType_choice_s rptest_TestStepType_choice;
/**
 * The rptest_TestStepType_o complex type, which represents an optional instance
 * of the choice used by the
 * {http://www.globus.org/namespaces/2004/10/ResourcePropertiesTest}choice 38 element.
 * @ingroup rptest_TestStepType
 */
typedef rptest_TestStepType_choice * rptest_TestStepType_choice_o;

typedef struct rptest_TestStepType_choice_array_s
{
    rptest_TestStepType_choice * elements;
    int                                 length;
} rptest_TestStepType_choice_array;

#define RPTEST_TESTSTEPTYPE_NS "http://www.globus.org/namespaces/2004/10/ResourcePropertiesTest"
#define RPTEST_TESTSTEPTYPE_LOCAL "TestStepType"

extern xsd_QName rptest_TestStepType_choice_qname;
extern struct globus_xsd_type_info_s rptest_TestStepType_choice_info;
extern struct globus_xsd_type_info_s rptest_TestStepType_choice_contents_info;
extern struct globus_xsd_type_info_s rptest_TestStepType_choice_array_info;


#include "rptest_GetResourcePropertyTestType.h"
#include "rptest_GetMultipleResourcePropertiesTestType.h"
#include "rptest_SetResourcePropertiesTestType.h"
#include "rptest_QueryResourcePropertiesTestType.h"

union rptest_TestStepType_u
{
    /** rptest_GetResourcePropertyTestType subelement */
    rptest_GetResourcePropertyTestType GetResourcePropertyTest;
    /** rptest_GetMultipleResourcePropertiesTestType subelement */
    rptest_GetMultipleResourcePropertiesTestType GetMultipleResourcePropertiesTest;
    /** rptest_SetResourcePropertiesTestType subelement */
    rptest_SetResourcePropertiesTestType SetResourcePropertiesTest;
    /** rptest_QueryResourcePropertiesTestType subelement */
    rptest_QueryResourcePropertiesTestType QueryResourcePropertiesTest;

};

struct rptest_TestStepType_choice_s
{
    rptest_TestStepType_enum type;
    rptest_TestStepType_union value;
};

globus_result_t
rptest_TestStepType_choice_init(
    rptest_TestStepType_choice ** inst);

void
rptest_TestStepType_choice_destroy(
    rptest_TestStepType_choice * inst);

globus_result_t
rptest_TestStepType_choice_copy(
    rptest_TestStepType_choice ** dest,
    const rptest_TestStepType_choice * src);

globus_result_t
rptest_TestStepType_choice_init_contents(
    rptest_TestStepType_choice * instance);

void
rptest_TestStepType_choice_destroy_contents(
    rptest_TestStepType_choice * inst);

globus_result_t
rptest_TestStepType_choice_copy_contents(
    rptest_TestStepType_choice * dest,
    const rptest_TestStepType_choice * src);
    
globus_result_t
rptest_TestStepType_choice_array_init(
    rptest_TestStepType_choice_array ** inst);

void
rptest_TestStepType_choice_array_destroy(
    rptest_TestStepType_choice_array * inst);

globus_result_t
rptest_TestStepType_choice_array_copy(
    rptest_TestStepType_choice_array ** dest,
    const rptest_TestStepType_choice_array * src);

globus_result_t
rptest_TestStepType_choice_array_init_contents(
    rptest_TestStepType_choice_array * inst);

void
rptest_TestStepType_choice_array_destroy_contents(
    rptest_TestStepType_choice_array * inst);

globus_result_t
rptest_TestStepType_choice_array_copy_contents(
    rptest_TestStepType_choice_array * dest,
    const rptest_TestStepType_choice_array * src);

rptest_TestStepType_choice *
rptest_TestStepType_choice_array_push(
    rptest_TestStepType_choice_array * array);

globus_result_t
rptest_TestStepType_choice_serialize(
    xsd_QName *                         element_name,
    rptest_TestStepType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
rptest_TestStepType_choice_serialize_contents(
    xsd_QName *                         element_name,
    rptest_TestStepType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
rptest_TestStepType_choice_deserialize(
    xsd_QName *                         element_name,
    rptest_TestStepType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
rptest_TestStepType_choice_deserialize_contents(
    xsd_QName *                         element_name,
    rptest_TestStepType_choice * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
rptest_TestStepType_choice_deserialize_pointer(
    xsd_QName *                         element_name,
    rptest_TestStepType_choice ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
rptest_TestStepType_choice_array_serialize(
    xsd_QName *                         element,
    rptest_TestStepType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
rptest_TestStepType_choice_array_deserialize(
    xsd_QName *                         element,
    rptest_TestStepType_choice_array * array_instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
rptest_TestStepType_choice_init_wrapper(
    void **                             object);
    
void
rptest_TestStepType_choice_destroy_wrapper(
    void *                              object);
    
globus_result_t
rptest_TestStepType_choice_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
rptest_TestStepType_choice_init_contents_wrapper(
    void *                              object);
    
void
rptest_TestStepType_choice_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
rptest_TestStepType_choice_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
rptest_TestStepType_choice_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
rptest_TestStepType_choice_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
rptest_TestStepType_choice_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
rptest_TestStepType_choice_array_serialize_wrapper(
    xsd_QName *                         element,
    void *                              instance,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
rptest_TestStepType_choice_array_deserialize_wrapper(
    xsd_QName *                         element_qname,
    void **                             inst,
    globus_soap_message_handle_t        message,
    globus_xsd_element_options_t        options);
    
globus_result_t
rptest_TestStepType_choice_array_init_wrapper(
    void **                             arr);
    
void
rptest_TestStepType_choice_array_destroy_wrapper(
    void *                              arr);
    
globus_result_t
rptest_TestStepType_choice_array_copy_wrapper(
    void **                             dest_arr,
    void *                              src_arr);

globus_result_t
rptest_TestStepType_choice_array_init_contents_wrapper(
    void *                              arr);

void
rptest_TestStepType_choice_array_destroy_contents_wrapper(
    void *                              arr);

globus_result_t
rptest_TestStepType_choice_array_copy_contents_wrapper(
    void *                              dest_arr,
    void *                              src_arr);

void *
rptest_TestStepType_choice_array_push_wrapper(
    void * array);

globus_result_t
rptest_TestStepType_choice_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
