/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


/*
 * This file is automatically generated by the Globus WSDLtoC converter
 */

#ifndef _WSDELEGATION_CERTTYPE_H_
#define _WSDELEGATION_CERTTYPE_H_

#include "globus_common.h"
#include "globus_xsd_type_info.h"

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_BEGIN
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

/**
 * The wsdelegation_certType complex type, which represents the
 * {http://www.globus.org/08/2004/delegationService}certType element.
 * @ingroup wsdelegation_certType
 */
typedef struct wsdelegation_certType_s wsdelegation_certType;
/**
 * The wsdelegation_certType_o complex type, which represents an optional instance
 * of a
 * {http://www.globus.org/08/2004/delegationService}certType element.
 * @ingroup wsdelegation_certType
 */
typedef wsdelegation_certType * wsdelegation_certType_o;

/**
 * Namespace of the wsdelegation_certType complex type
 * @ingroup wsdelegation_certType
 */
#define WSDELEGATION_CERTTYPE_NS "http://www.globus.org/08/2004/delegationService"
/**
 * Local part of the QName of the wsdelegation_certType complex type
 * @ingroup wsdelegation_certType
 */
#define WSDELEGATION_CERTTYPE_LOCAL "certType"

/**
 * QName of the wsdelegation_certType complex type
 * @ingroup wsdelegation_certType
 */
extern xsd_QName wsdelegation_certType_qname;
/**
 * Type information for serializing and deserializing wsdelegation_certType elements
 * @ingroup wsdelegation_certType
 */
extern struct globus_xsd_type_info_s wsdelegation_certType_info;
/**
 * Type information for serializing and deserializing arrays of wsdelegation_certType
 * elements
 * @ingroup wsdelegation_certType
 */
extern struct globus_xsd_type_info_s wsdelegation_certType_array_info;
/**
 * Type information for serializing and deserializing the contents of
 * wsdelegation_certType without surrounding elements
 * @ingroup wsdelegation_certType
 */
extern struct globus_xsd_type_info_s wsdelegation_certType_contents_info;


#include "xsd_any.h"
#include "wsdelegation_certType_array.h"

/**
 * @defgroup wsdelegation_certType Complex type: wsdelegation_certType
 * @ingroup types
 */

/**
 * C structure for the wsdelegation_certType complex type
 * @ingroup wsdelegation_certType
 */
struct wsdelegation_certType_s
{
    /** xsd_any subelement */
    xsd_any any;

};

/**
 * Initialize a wsdelegation_certType
 * @ingroup wsdelegation_certType
 *
 * Allocates a new wsdelegation_certType and initializes its contents. When the
 * structure is no longer needed, it should be freed by calling 
 * wsdelegation_certType_destroy(). 
 *
 * @param inst
 *     Pointer to set to a newly allocated instance.
 */
globus_result_t
wsdelegation_certType_init(
    wsdelegation_certType ** inst);

/**
 * Destroy a wsdelegation_certType
 * @ingroup wsdelegation_certType
 *
 * Frees a wsdelegation_certType. All subelements and attributes will be destroyed
 * (and freed if they are optional).
 *
 * @param inst
 *     Pointer to the instance to destroy.
 */
void
wsdelegation_certType_destroy(
    wsdelegation_certType * inst);

/**
 * Copy a wsdelegation_certType
 * @ingroup wsdelegation_certType
 *
 * Perform a deep copy of a wsdelegation_certType.
 * The @a dest structure will be allocated, and then a copy of the contents
 * of @a src and its subelements and attributes will be made to @a dest.
 * 
 * @param dest
 *     The wsdelegation_certType structure to be initialized with a copy of the
 *     contents of the @a src structure.
 * @param src
 *     Source wsdelegation_certType to be copied.
 */
globus_result_t
wsdelegation_certType_copy(
    wsdelegation_certType ** dest,
    const wsdelegation_certType * src);

/**
 * Initialize the contents of a wsdelegation_certType
 * @ingroup wsdelegation_certType
 *
 * Initialize the contents of a wsdelegation_certType. This should be used
 * when the structure is allocated on the stack or by a some allocator besides
 * wsdelegation_certType_init(). The contents may be freed
 * by calling wsdelegation_certType_destroy_contents().
 *
 * @param instance
 *     Pointer to an allocated but uninitialized wsdelegation_certType.
 */
globus_result_t
wsdelegation_certType_init_contents(
    wsdelegation_certType * instance);

/**
 * Destroy the contents of a wsdelegation_certType
 * @ingroup wsdelegation_certType
 *
 * Destroy the subelements and attributes of the given wsdelegation_certType. 
 *
 * @param inst
 *     Pointer to a wsdelegation_certType instance to destroy.
 */
void
wsdelegation_certType_destroy_contents(
    wsdelegation_certType * inst);

/**
 * Copy the contents of a wsdelegation_certType
 * @ingroup wsdelegation_certType
 *
 * Perform a deep copy of the contents of a wsdelegation_certType.
 * The @a dest strcuture must be allocated before making this call.
 * A copy of the subelements and attributes of @ src will be made to
 * @a dest.
 * 
 * @param dest
 *     Structure to be initialized with copies of the contents of @a src.
 * @param src
 *     Source wsdelegation_certType to be copied.
 */
globus_result_t
wsdelegation_certType_copy_contents(
    wsdelegation_certType * dest,
    const wsdelegation_certType * src);

/**
 * Serialize a wsdelegation_certType
 * @ingroup wsdelegation_certType_array
 * Serialize a wsdelegation_certType structure.
 *
 * @param element_name
 *     The name of the element which will contain the wsdelegation_certType.
 * @param val
 *     The wsdelegation_certType to serialize.
 * @param message_handle
 *     The handle to serialize the element on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsdelegation_certType_serialize(
    xsd_QName *                         element_name,
    wsdelegation_certType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Serialize the contents of a wsdelegation_certType
 * @ingroup wsdelegation_certType_array
 * Serialize a wsdelegation_certType structure without an enclosing element.
 *
 * @param element_name
 *     Ignored parameter.
 * @param val
 *     The wsdelegation_certType to serialize.
 * @param message_handle
 *     The handle to serialize the contents on.
 * @param options
 *     Serialization options.
 */
globus_result_t
wsdelegation_certType_serialize_contents(
    xsd_QName *                         element_name,
    wsdelegation_certType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsdelegation_certType
 * @ingroup wsdelegation_certType
 * Deserialize an element containing a wsdelegation_certType element.
 *
 * @param element_name
 *     The name of the element which should enclose the wsdelegation_certType.
 * @param val
 *     Pointer to the wsdelegation_certType which will be initialized with the
 *     value of the element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsdelegation_certType_deserialize(
    xsd_QName *                         element_name,
    wsdelegation_certType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize a wsdelegation_certType
 * @ingroup wsdelegation_certType
 * Deserialize a wsdelegation_certType whose enclosing element has already been
 * deserialized.
 *
 * @param element_name
 *     Ignored.
 * @param val
 *     Pointer to the wsdelegation_certType which will be initialized with the
 *     value of the current element.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsdelegation_certType_deserialize_contents(
    xsd_QName *                         element_name,
    wsdelegation_certType * val,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

/**
 * Deserialize an optional wsdelegation_certType
 * @ingroup wsdelegation_certType
 * Deserialize the next element if it contains a wsdelegation_certType.
 *
 * @param element_name
 *     The name of the element which should enclose the wsdelegation_certType.
 * @param instance
 *     Pointer to the <code>wsdelegation_certType *</code> which will be allocated
 *     and initialized with the value of the element if it is present.
 * @param message_handle
 *     The handle to deserialize the element from.
 * @param options
 *     Deserialization options.
 */
globus_result_t
wsdelegation_certType_deserialize_pointer(
    xsd_QName *                         element_name,
    wsdelegation_certType ** instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

globus_result_t
wsdelegation_certType_init_wrapper(
    void **                             object);
    
void
wsdelegation_certType_destroy_wrapper(
    void *                              object);
    
globus_result_t
wsdelegation_certType_copy_wrapper(
    void **                             dest_obj,
    void *                              src_obj);

globus_result_t
wsdelegation_certType_init_contents_wrapper(
    void *                              object);
    
void
wsdelegation_certType_destroy_contents_wrapper(
    void *                              object);
    
globus_result_t
wsdelegation_certType_copy_contents_wrapper(
    void *                              dest_obj,
    void *                              src_obj);

globus_result_t
wsdelegation_certType_serialize_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsdelegation_certType_serialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void *                              instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
    
globus_result_t
wsdelegation_certType_deserialize_contents_wrapper(
    xsd_QName *                         element_qname,
    void **                             instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);

globus_result_t
wsdelegation_certType_deserialize_pointer_wrapper(
    xsd_QName *                         element_qname,
    void **                             ip,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options);
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
EXTERN_C_END
#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

#endif
